Ext.define('DSS.component.TriggerConfigurator', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : '100%',
    iDefaultWidth : 150,
    setHeight : function(oHeight) {
        this.macPanel.setHeight(oHeight);
        this.iDefaultHeight = oHeight - 2;
        for ( var oKey in this.grids)
            this.grids[oKey].setHeight(this.iDefaultHeight);
        this.callParent(arguments);
    },
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:10px;width:100%;"><tr style="height:10px;"><td width="100%"><hr></td></tr></table>';
        } 
        var fHasIcon=false; 
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if (record.get('group') != null)   // ist eine gruppe -> weiterbutton
        {
            fHasNext=true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null))   // ist ein device -> weiterbutton
        {
            fHasNext=true;
            var sTooltip=dss.staticDataModel.getTooltipForDevice(dss.staticDataModel.getDevice(record.get('dSUID')));
            if (sTooltip!="")
            	metadata.tdAttr = 'data-qtip="'+sTooltip+'"';
        }
        if (record.get('tooltip')!=null) {
        	if (record.get('tooltip')!="")
        		metadata.tdAttr = 'data-qtip="' + record.get('tooltip') + '"';
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) {
            fHasNext=false; // checkboxen niemals weiterbuttons
            fHasIcon=false; // keine Icons nach Checkboxen
            fIsCheckable=true;
        }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }
        
        var sReturn='<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';      
    },
    initStores : function(fShowUserstates) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_l1Store') == null) {
            var Aktionen = [ {
                name : _('activity in room'),
                _id : 0,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }, {
                name : _('activity on device'),
                _id : 1,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }, {
                name : _('automatic devices'),
                _id : 7,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getAKMDeviceArray().length==0)
            }];
            
            Aktionen.push({
                name : _("consumptionmessage"),
                _id : 3,
                next : true,
                icon : null,
                passive:(dss.staticDataModel.getSensorDeviceArray().length==0)
            });
            Aktionen.push({
                name : _('zone trigger'),
                _id : 9,
                next : true,
                icon : null
            });
            
            if (dss.staticDataModel.clusterAvaible)
            	Aktionen.push({
                    name : _('cluster trigger'),
                    _id : 11,
                    next : true,
                    icon : null,
                    passive:(dss.staticDataModel.getUsergroups().length==0)
                });
            
            Aktionen.push({
                name : '-',
                _id : -1,
                passive:true,
                next : false,
                icon : null
            });
            
            Aktionen.push({
                name : _('user def. actions'),
                _id : 2,
                next : true,
                icon : null,
                passive:(dss.staticDataModel.getHLE().length==0)
            });
            if (dss.staticDataModel.getUserStates().length>0) {
	            Aktionen.push( { 
	                name : _('user states'),
	                _id : 8,
	                next : true,
	                icon : null,
	                passive:(dss.staticDataModel.getUserStates().length==0)            	
	            });
            }
            
 
            Aktionen.push({
                name : '-',
                _id : -1,
                passive:true,
                next : false,
                icon : null
            });
            
            Aktionen.push( {
                name : _("access trigger"),
                _id : 4,
                next : true,
                icon : null
            });
            Aktionen.push( {
                name : _('weather trigger'),
                _id : 5,
                next : true,
                icon : null
            });
            Aktionen.push( {
                name : _('security trigger'),
                _id : 6,
                next : true,
                icon : null
            });
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_l1Store',
                fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_l1Store').add(Aktionen);
        }
        
    	if (Ext.data.StoreManager.lookup('triggerConfigurator_userStateStore') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_userStateStore',
                fields : [ '_id', 'name', 'next', 'icon' ,'type'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            
    		var oUserStates=dss.staticDataModel.getUserStates();
    		
    		for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
    			var Aktionen = [{
                    name : oUserStates[iIndex].displayName,
                    _id : oUserStates[iIndex].name,
                    next : true,
                    icon : null,
                    type: oUserStates[iIndex].type
                }];
    			Ext.data.StoreManager.lookup('triggerConfigurator_userStateStore').add(Aktionen);
    		}
            

    	}
        if (Ext.data.StoreManager.lookup('triggerConfigurator_zoneZoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_zoneZoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_zoneZoneStore').add(dss.staticDataModel.getZoneArray());
        }
        if (Ext.data.StoreManager.lookup('triggerConfigurator_deviceZoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_deviceZoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            for (var iIndex=0;iIndex<dss.staticDataModel.getZoneArray().length;iIndex++) {
            	if (this.getDeviceStore(dss.staticDataModel.getZoneArray()[iIndex].ZoneID).count()>0) {
            		Ext.data.StoreManager.lookup('triggerConfigurator_deviceZoneStore').add(dss.staticDataModel.getZoneArray()[iIndex]);            		
            	}
            }
        }
        
        if (Ext.data.StoreManager.lookup('triggerConfigurator_clusterStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_clusterStore',
                fields : [ 'id', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_clusterStore').add(dss.staticDataModel.getUsergroups());
        }
        if (Ext.data.StoreManager.lookup('triggerConfigurator_zoneSensorStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_zoneSensorStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oArray=dss.staticDataModel.getZoneArray();
            var deviceArray=dss.staticDataModel.getSensorDeviceArray();
            for (var iIndex=0;iIndex<oArray.length;iIndex++) {
                var fAdd=false;                
                for (var jIndex=0;jIndex<deviceArray.length;jIndex++) {
                    if (deviceArray[jIndex].ZoneID==oArray[iIndex].ZoneID)
                        fAdd=true;
                }                    
                if (fAdd) {
                    Ext.data.StoreManager.lookup('triggerConfigurator_zoneSensorStore').add(oArray[iIndex]);
                }
            }
        }
        if (Ext.data.StoreManager.lookup('triggerConfigurator_zoneAKMStore') == null) {
        
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_zoneAKMStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oArray=dss.staticDataModel.getZoneArray();
            var deviceArray=dss.staticDataModel.getAKMDeviceArray();
            for (var iIndex=0;iIndex<oArray.length;iIndex++) {
                var fAdd=false;                
                for (var jIndex=0;jIndex<deviceArray.length;jIndex++) {
                    if (deviceArray[jIndex].ZoneID==oArray[iIndex].ZoneID)
                        fAdd=true;
                }  
                for (var jIndex=0;jIndex<dss.staticDataModel.deviceCache.length;jIndex++) {
                	if (dss.staticDataModel.deviceCache[jIndex].present)
                		if (dss.staticDataModel.deviceCache[jIndex].ZoneID==oArray[iIndex].ZoneID)
		                	if (dss.staticDataModel.deviceCache[jIndex].specialActions!=null)
		                		if (dss.staticDataModel.deviceCache[jIndex].specialActions.triggers!=null)
		                			if (dss.staticDataModel.deviceCache[jIndex].specialActions.triggers.binaryInputs!=null) 
		                				for (var sKey in dss.staticDataModel.deviceCache[jIndex].specialActions.triggers.binaryInputs) {                				
			                				fAdd=true;                				
			                			}
                }
                if (fAdd) {
                    Ext.data.StoreManager.lookup('triggerConfigurator_zoneAKMStore').add(oArray[iIndex]);
                }
            }
        }
                
        if (Ext.data.StoreManager.lookup('triggerConfigurator_accessStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForScene(0, 0, 73),
                _id : 73,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 73)
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 72),
                _id : 72,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 72)
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 71),
                _id : 71,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 71)
            } ];
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_accessStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_accessStore').add(Aktionen);
        }
        
        if (Ext.data.StoreManager.lookup('triggerConfigurator_weatherStore') == null) {
            var Aktionen = [{
                name : _("Sun protection"),
                _id : 'sun',
                next : true,
                icon : dss.staticDataModel.getImagePathForState('sun', 'active')
            },{
                name : dss.staticDataModel.getNameForState('rain', 'active'),
                _id : 'rain_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('rain', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('rain', 'inactive'),
                _id : 'rain_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('rain', 'inactive')
            },{
            	name : dss.staticDataModel.getNameForState('wind', 'active'),
                _id : 'wind_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('wind', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('wind', 'inactive'),
                _id : 'wind_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('wind', 'inactive')
            },{
            	name : dss.staticDataModel.getNameForState('hail', 'active'),
                _id : 'hail_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('hail', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('hail', 'inactive'),
                _id : 'hail_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('hail', 'inactive')
            }];
            
            var fFrost=false;
            var fSun=false;
            var fHeating=false;
            var fService=false;
            for (var iIndex=0;iIndex<dss.staticDataModel.StateCache.length;iIndex++) {
            	if (dss.staticDataModel.StateCache[iIndex].name=='frost')
            		fFrost=true;
            	if (dss.staticDataModel.StateCache[iIndex].name=='sun')
            		fSun=true;
            	if (dss.staticDataModel.StateCache[iIndex].name=='heating_mode')
            		fHeating=true;
            	if (dss.staticDataModel.StateCache[iIndex].name=='service')
            		fService=true;
            }
            	
            if (fFrost) {
            	Aktionen.push({            
	                name : dss.staticDataModel.getNameForState('frost', 'active'),
	                _id : 'frost_active',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('frost', 'active')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('frost', 'inactive'),
	                _id : 'frost_inactive',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('frost', 'inactive')
	            });
            }
            
            if (fSun) {
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('sun', 'active'),
	                _id : 'sun_active',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('sun', 'active')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('sun', 'inactive'),
	                _id : 'sun_inactive',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('sun', 'inactive')
	            });
            }
            
            if (fHeating) {
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'off'),
	                _id : 'heating_mode_off',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'off')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'heating'),
	                _id : 'heating_mode_heating',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'heating')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'cooling'),
	                _id : 'heating_mode_cooling',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'cooling')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('heating_mode', 'auto'),
	                _id : 'heating_mode_auto',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('heating_mode', 'auto')
	            });
            }
            
            if (fService) {
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('service', 'active'),
	                _id : 'service_active',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('service', 'active')
	            });
	            Aktionen.push({
	                name : dss.staticDataModel.getNameForState('service', 'inactive'),
	                _id : 'service_inactive',
	                next : false,
	                icon : dss.staticDataModel.getImagePathForState('service', 'inactive')
	            });
            }
            
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_weatherStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_weatherStore').add(Aktionen);
        }

        if (Ext.data.StoreManager.lookup('triggerConfigurator_weatherSunStore') == null) {
            var Aktionen = [];
            var protectionDirections = ['east', 'south', 'west'];
            for (var dir in protectionDirections) {
                Aktionen.push({
                    name : Ext.String.format2(_("Sun protection {direction} {state}"), {direction: _(protectionDirections[dir]), state: _("active")}),
                    _id : 'sun_' + protectionDirections[dir] + '_active',
                    eventName : 'sunshine',
                    value : 1,
                    direction : protectionDirections[dir],
                    next : false,
                    icon : dss.staticDataModel.getImagePathForState('sun', 'active')
                });
                Aktionen.push({
                    name : Ext.String.format2(_("Sun protection {direction} {state}"), {direction: _(protectionDirections[dir]), state: _("inactive")}),
                    _id : 'sun_' + protectionDirections[dir] + '_inactive',
                    eventName : 'sunshine',
                    value : 2,
                    direction : protectionDirections[dir],
                    next : false,
                    icon : dss.staticDataModel.getImagePathForState('sun', 'inactive')
                });
            }

            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_weatherSunStore',
                fields : [ '_id', 'name', 'next', 'icon', 'value', 'direction', 'eventName' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_weatherSunStore').add(Aktionen);
        }

        if (Ext.data.StoreManager.lookup('triggerConfigurator_securityStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForScene(0, 0, 65),
                _id : 65,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 65)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 65),
                _id : 1065,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 65,true)
            },{
            	name : dss.staticDataModel.getNameForState('fire', 'active'),
                _id : 'fire_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('fire', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('fire', 'inactive'),
                _id : 'fire_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('fire', 'inactive')
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 74),
                _id : 74,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 74)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 74),
                _id : 1074,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 74,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 83),
                _id : 83,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 83)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 83),
                _id : 1083,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 83,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 84),
                _id : 84,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 84)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 84),
                _id : 1084,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 84,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 85),
                _id : 85,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 85)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 85),
                _id : 1085,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 85,true)
            }];
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_securityStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('triggerConfigurator_securityStore').add(Aktionen);
        }
        
    },
    getGroupStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_groupStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_groupStore_' + ZoneID,
                fields : [ 'group', 'name', 'icon', 'reachable' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oGroup = dss.staticDataModel.getGroupForZone(ZoneID);
            Ext.data.StoreManager.lookup('triggerConfigurator_groupStore_' + ZoneID).add(oGroup);
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_groupStore_' + ZoneID);
    },
    getSceneStore : function(ZoneID, groupID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID,
                fields : [ '_id', 'name', 'reachable', 'icon', 'outputMode','forced' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oScenes = dss.staticDataModel.getScenes(ZoneID, groupID);
            for ( var iIndex = 0; iIndex < oScenes.length; iIndex++) {
                var oObject = {};
                oObject._id = oScenes[iIndex].id;
                oObject.reachable = oScenes[iIndex].reachable;
                oObject.icon = oScenes[iIndex].icon;
                if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                    oObject.name = oScenes[iIndex].name;
                else
                    oObject.name = oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
                
                if (oObject.undoable) {
                    oObject = {};
                    oObject._id = -1 * oScenes[iIndex].id;
                    oObject.reachable = oScenes[iIndex].reachable;
                    oObject.icon = oScenes[iIndex].icon;
                    if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                        oObject.name = _('Undo ') + oScenes[iIndex].name;
                    else
                        oObject.name = _('Undo ') + oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                    Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
                }
                
                if (oScenes[iIndex].id==0) {
                    if (groupID==2) {
                    	Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add({
                            _id:0,
                            name:_('all closed'),
                            icon: oScenes[iIndex].icon,
                            reachable : oScenes[iIndex].reachable,
                            forced:true
                        });
                    } else {
                    	Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID).add({
                            _id:0,
                            name:_('all off'),
                            icon: oScenes[iIndex].icon,
                            reachable : oScenes[iIndex].reachable,
                            forced:true
                        });
                    }
                }                
            }
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_szeneStore_' + ZoneID + '_' + groupID);
    },
    getSensorMessage : function(dSUID)
    {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_sensorMessageStore_' + dSUID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_sensorMessageStore_' + dSUID,
                fields : [ 'name','_id'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray =  dss.staticDataModel.getSensorDeviceArray();
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((dSUID==-1) || (oDeviceArray[iIndex].dSUID==dSUID)) {                
                    for (var jIndex=0;jIndex<oDeviceArray[iIndex].sensorEvents.length;jIndex++)
                        Ext.data.StoreManager.lookup('triggerConfigurator_sensorMessageStore_' + dSUID).add({name:oDeviceArray[iIndex].sensorEvents[jIndex].name,_id:oDeviceArray[iIndex].sensorEvents[jIndex].id});
                }
            }            
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_sensorMessageStore_' + dSUID);
    },
    getSensorDeviceStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_deviceSensorStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_deviceSensorStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray =  dss.staticDataModel.getSensorDeviceArray();
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((ZoneID==0) || (ZoneID==oDeviceArray[iIndex].ZoneID))     
                        Ext.data.StoreManager.lookup('triggerConfigurator_deviceSensorStore_' + ZoneID).add(oDeviceArray[iIndex]);
            }
            
        }
        return Ext.data.StoreManager.lookup('triggerConfigurator_deviceSensorStore_' + ZoneID);
    },    
    getDeviceAKMStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_deviceAKMStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_deviceAKMStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray =  dss.staticDataModel.getAKMDeviceArray();
            var targetArray=[];
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((ZoneID==0) || (ZoneID==oDeviceArray[iIndex].ZoneID))     
                	targetArray.push(oDeviceArray[iIndex]);
            }
                                                     
            for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
            	var fAdd=false;
            	if (dss.staticDataModel.deviceCache[iIndex].present)
            		if (dss.staticDataModel.deviceCache[iIndex].ZoneID==ZoneID)
	            		if (dss.staticDataModel.deviceCache[iIndex].specialActions!=null)
	            			if (dss.staticDataModel.deviceCache[iIndex].specialActions.triggers!=null)
	            				if (dss.staticDataModel.deviceCache[iIndex].specialActions.triggers.binaryInputs!=null)
	                				for (var sKey in dss.staticDataModel.deviceCache[iIndex].specialActions.triggers.binaryInputs) {                				
		                				fAdd=true;                				
		                			}
            	if (fAdd) 
            		for (var jIndex=0;jIndex<targetArray.length;jIndex++) {
            			if (targetArray[jIndex].dSUID==dss.staticDataModel.deviceCache[iIndex].dSUID)
            				fAdd=false;
            		}
            	if (fAdd) {            		
            		targetArray.push(dss.staticDataModel.deviceCache[iIndex]);
            	}
            }
            Ext.data.StoreManager.lookup('triggerConfigurator_deviceAKMStore_' + ZoneID).add(targetArray);
        }        
        
        return Ext.data.StoreManager.lookup('triggerConfigurator_deviceAKMStore_' + ZoneID);
    },
    getDeviceStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('triggerConfigurator_deviceStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'triggerConfigurator_deviceStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray = dss.staticDataModel.getDevicesForZone(ZoneID, 0);
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
            	var fShouldAdd=false;
            	if (oDeviceArray[iIndex].hasStates)
            		fShouldAdd=true;
            	if (oDeviceArray[iIndex].deviceEvents!=null)
            		if (Object.keys(oDeviceArray[iIndex].deviceEvents).length>0)
            			fShouldAdd=true;
            	if (oDeviceArray[iIndex].deviceCustomActions!=null)
            		if (Object.keys(oDeviceArray[iIndex].deviceCustomActions).length>0)
            			fShouldAdd=true;
            	if (oDeviceArray[iIndex].deviceStandardActions!=null)
            		if (Object.keys(oDeviceArray[iIndex].deviceStandardActions).length>0)
            			fShouldAdd=true;

                if (((oDeviceArray[iIndex].tasterMode == 0) && (oDeviceArray[iIndex].buttonType != 65))||(oDeviceArray[iIndex].tasterMode==15))
                	fShouldAdd=true;
                else
                	if (oDeviceArray[iIndex].specialActions!=null)
                    	if (oDeviceArray[iIndex].specialActions.triggers!=null) {
                        	if (oDeviceArray[iIndex].specialActions.triggers.deviceMsg!=null)
                        		fShouldAdd=true;
                        	if (oDeviceArray[iIndex].specialActions.triggers.deviceAction!=null)
                        		fShouldAdd=true;                        	
                    	}
                if (fShouldAdd)
                	Ext.data.StoreManager.lookup('triggerConfigurator_deviceStore_' + ZoneID).add(oDeviceArray[iIndex]);
            }
        }        
        return Ext.data.StoreManager.lookup('triggerConfigurator_deviceStore_' + ZoneID);
    },
    constructGridLvlRoomStateState: function (zoneID) {
    	var oStates=dss.staticDataModel.getStates();
    	var oShowStates=[];
    	for (var iIndex=0;iIndex<oStates.length;iIndex++) {
    		var sSplitName=oStates[iIndex].name.split(".");
    		if (sSplitName.length==3)
    			if (sSplitName[0]=='zone')
    				if ((sSplitName[1]==''+zoneID) && (sSplitName[2] != 'heating')){
    					oShowStates.push(oStates[iIndex]);
    				}
    	}
    	oShowStates.sort(function (o1,o2) {if (o1.name<o2.name)return -1; else return 1;});
    		
        var oRoomStateStateControlStore = Ext.create('Ext.data.Store', {
            fields : [  'name','stateid','value','icon','tooltip','valueandstate'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oNewArray=[];
    	for (var iIndex=0;iIndex<oShowStates.length;iIndex++) {
    		var oNameArray=oShowStates[iIndex].name.split('.');
            var oItem={
            		'stateid':oShowStates[iIndex].name,
            		'value':'active',
            		'tooltip':"",
            		'icon': "",
            		'valueandstate':oShowStates[iIndex].name+'_active'};
            if (oNameArray[2]=='light') {
            	oItem.icon=dss.staticDataModel.getImagePathForScene(0,1,5);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}light is active"),{});
            }            	
            else if (oNameArray[2]=='motion') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(5,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}motion is active"),{});
            }            	
            else if (oNameArray[2]=='presence') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(1,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}presence is active"),{});
            }            	
            else {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(0,true);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}{state} is active"),{'state':oNameArray[2]});
            }            	
            oNewArray.push(oItem);
            
            oItem={
            		'stateid':oShowStates[iIndex].name,
            		'value':'inactive',
            		'tooltip':"",
            		'icon': "",
            		'valueandstate':oShowStates[iIndex].name+'_inactive'};
            if (oNameArray[2]=='light') {
            	oItem.icon=dss.staticDataModel.getImagePathForScene(0,1,0);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}light is inactive"),{});
            }
            else if (oNameArray[2]=='motion') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(5,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}motion is inactive"),{});
            }
            else if (oNameArray[2]=='presence') {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(1,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}presence is inactive"),{});
            }            	
            else {
            	oItem.icon=dss.staticDataModel.getImagePathForAKMValue(0,false);
            	oItem.name=Ext.String.format2(_("{#editor_trigger_zonestates}{state} is inactive"),{'state':oNameArray[2]});
            }            	
            oNewArray.push(oItem);            
    	}
        oRoomStateStateControlStore.add(oNewArray);

    	this.grids.lvlRoomStateState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : (this.getWidth()-(this.iDefaultWidth*2))-2,//474,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomStateStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : this.defMacGridRenderer                
            } ]
        });

        this.grids.lvlRoomStateState.parent = this;

        
        var me=this;
        this.grids.lvlRoomStateState.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });

        
        this.macPanel.add(this.grids.lvlRoomStateState);
    	
    },
    constructGridLvlClusterStateState: function (clusterID) {
        var oStates = dss.staticDataModel.getStates();
        var oShowStates = [];
        for (var iIndex = 0; iIndex < oStates.length; iIndex++) {
            var sSplitName = oStates[iIndex].name.split(".");
            if ((sSplitName.length != 3) && (sSplitName[0] != 'cluster')) {
                continue;
            }
            if ((sSplitName[1] == ''+clusterID) && (sSplitName[2] == 'operation_lock')) {
                oShowStates.push(oStates[iIndex]);
            }
        }
        oShowStates.sort(function (o1,o2) { if (o1.name < o2.name) return -1; else return 1;});

        var oClusterStateStateControlStore = Ext.create('Ext.data.Store', {
            fields : [  'name', 'stateid', 'value', 'icon', 'tooltip', 'valueandstate'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oNewArray=[];
        for (var iIndex = 0; iIndex < oShowStates.length; iIndex++) {
            var oNameArray = oShowStates[iIndex].name.split('.');
            var oItem={
                    'stateid': oShowStates[iIndex].name,
                    'value': 'active',
                    'tooltip': "",
                    'icon': "",
                    'valueandstate': oShowStates[iIndex].name+'_active'};
            if (oNameArray[2] == 'operation_lock') {
                oItem.icon=dss.staticDataModel.getImagePathForState("operation_lock", "active");
                oItem.name=Ext.String.format2(_("{#editor_trigger_clusterstates}Operation is locked"),{});
            }
            oNewArray.push(oItem);

            oItem={
                    'stateid': oShowStates[iIndex].name,
                    'value': 'inactive',
                    'tooltip': "",
                    'icon': "",
                    'valueandstate': oShowStates[iIndex].name+'_inactive'};
            if (oNameArray[2] == 'operation_lock') {
                oItem.icon=dss.staticDataModel.getImagePathForState("operation_lock", "inactive");
                oItem.name=Ext.String.format2(_("{#editor_trigger_clusterstates}Operation is free"),{});
            }
            oNewArray.push(oItem);
        }
        oClusterStateStateControlStore.add(oNewArray);

        this.grids.lvlClusterStateState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : (this.getWidth()-(this.iDefaultWidth*2))-2,//474,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oClusterStateStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('cluster'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        var me=this;
        this.grids.lvlClusterStateState.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });

        
        this.grids.lvlClusterStateState.parent = this;

        this.macPanel.add(this.grids.lvlClusterStateState);
    },
    constructGridLvlDeviceStateValue: function (dSUID,type) {
    	var oStates=dss.staticDataModel.getDeviceStates(dSUID);
    	
        var oStateDeviceValueControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'type', 'name','selector' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oValueArray=[];
    	for (var sKey in oStates) {
    		if (sKey==type) {
    			for (var sSubKey in oStates[sKey].options)
    			oValueArray.push({type:sSubKey,name:oStates[sKey].options[sSubKey],selector:'dev.' + dSUID + '.' + type});
    		}    		
    	}
    	oStateDeviceValueControlStore.add(oValueArray);    	
    	oStateDeviceValueControlStore.sort('name');

        var width=(this.getWidth()-(this.iDefaultWidth*4))-2;
        if (this.grids.lvlDeviceActionClass.store.count()==1) 
       	 width+=this.iDefaultWidth;
        
    	 this.grids.lvlDeviceStateValue = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             height : this.iDefaultHeight,
             width :  width,
             autoScroll : true,
             viewConfig : {
                 stripeRows : true
             },
             selModel : {
                             mode : 'MULTI'
                         },
             store : oStateDeviceValueControlStore,
             columns : [ {
                 sortable : false,
                 hideable : false,
                 text : _('room'),
                 dataIndex : 'name',
                 flex : 1,                
                 renderer : function(val, metadata, record, colIdx, store, view) {
                     return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td></tr></table>';
                 }
             } ]
         });

         this.grids.lvlDeviceStateValue.parent = this;
         this.grids.lvlDeviceStateValue.on('itemclick', function(grid, record) {
             var value = record.get('type');
             var selector = record.get('selector');
         });
         var me=this;
         this.grids.lvlDeviceStateValue.on('itemdblclick', function(grid, record) {
         	if (me.isValid())
         		me.fireEvent('valueDoubleClicked', me);
         });
         
         this.macPanel.add(this.grids.lvlDeviceStateValue);
    },
    /*
    constructGridLvlDeviceStateState: function (dSUID) {
    	var oStates=dss.staticDataModel.getDeviceStates(dSUID);
    	
        var oStateDeviceStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'type', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oStateArray=[];
    	for (var sKey in oStates) {
    		oStateArray.push({type:sKey,name:oStates[sKey].title});
    	}
    	oStateDeviceStateControlStore.add(oStateArray);
    	
    	oStateDeviceStateControlStore.sort('name');
         
         this.grids.lvlDeviceStateState = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             height : this.iDefaultHeight,
             width : this.iDefaultWidth,
             autoScroll : true,
             viewConfig : {
                 stripeRows : true
             },
             store : oStateDeviceStateControlStore,
             columns : [ {
                 sortable : false,
                 hideable : false,
                 text : _('room'),
                 dataIndex : 'name',
                 flex : 1,                
                 renderer : function(val, metadata, record, colIdx, store, view) {
                     return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                 }
             } ]
         });

         this.grids.lvlDeviceStateState.parent = this;
         this.grids.lvlDeviceStateState.on('itemclick', function(grid, record) {
             this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateValue);
             var type = record.get('type');
             this.parent.constructGridLvlDeviceStateValue(dSUID,type);           
         });
         this.macPanel.add(this.grids.lvlDeviceStateState);
         
    	
    },
    *//*
    constructGridLvlDeviceStateDevice: function (zoneID) {
    	var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
    	
    	var oDeviceArray=[];
    	for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
    		if (dss.staticDataModel.deviceCache[iIndex].present)
    			if (dss.staticDataModel.deviceCache[iIndex].hasStates)
    				if (dss.staticDataModel.deviceCache[iIndex].ZoneID==zoneID) {
    					oDeviceControlStore.add(dss.staticDataModel.deviceCache[iIndex]);    					
    				}
    	}


    	oDeviceControlStore.sort('name');
        this.grids.lvlDeviceStateDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceStateDevice.parent = this;
        this.grids.lvlDeviceStateDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateState);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateValue);
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlDeviceStateState(dSUID);
        });
        this.macPanel.add(this.grids.lvlDeviceStateDevice);

		
    },*//*
    constructGridLvlDeviceStateRoom: function () {
    	var oRoomArray=[];
    	for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
    		if (dss.staticDataModel.deviceCache[iIndex].present)
    			if (dss.staticDataModel.deviceCache[iIndex].hasStates)
    				if (oRoomArray.indexOf(dss.staticDataModel.deviceCache[iIndex].ZoneID)<0) {
    					oRoomArray.push(dss.staticDataModel.deviceCache[iIndex].ZoneID);
    				}
    	}
        var oRoomDeviceStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oArray=[];
        for (var iIndex=0;iIndex<oRoomArray.length;iIndex++) {
        	oArray.push({ZoneID:oRoomArray[iIndex],name:dss.staticDataModel.getNameForZone(oRoomArray[iIndex])});
        }
        oRoomDeviceStateControlStore.add(oArray);
        oRoomDeviceStateControlStore.sort('name');
        
        this.grids.lvlDeviceStateRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomDeviceStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlDeviceStateRoom.parent = this;
        this.grids.lvlDeviceStateRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateState);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateValue);
            var zoneID = record.get('ZoneID');
            this.parent.constructGridLvlDeviceStateDevice(zoneID);           
        });
        this.macPanel.add(this.grids.lvlDeviceStateRoom);
        
    },*/
    constructGridLvlRoomStateRoom: function () {
        var oRoomStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneZoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
            	oRoomStateControlStore.add(oNewRecord);
        });
        oRoomStateControlStore.sort('name');
      
        this.grids.lvlRoomStateRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoomStateRoom.parent = this;
        this.grids.lvlRoomStateRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlRoomStateState);
           
            var zoneID = record.get('ZoneID');
            this.parent.constructGridLvlRoomStateState(zoneID);           
        });
        this.macPanel.add(this.grids.lvlRoomStateRoom);
    },  
    constructGridLvlDeviceEventEvent: function (dSUID) {
    	var oEvents=dss.staticDataModel.getDevice(dSUID).deviceEvents;
    	
        var oStateDeviceEventControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'event','dSUID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oEventArray=[];
    	for (var sKey in oEvents) {
    		oEventArray.push({event:sKey,dSUID:dSUID,name:oEvents[sKey].title});
    	}
    	oStateDeviceEventControlStore.add(oEventArray);
    	
    	oStateDeviceEventControlStore.sort('name');
         var width=(this.getWidth()-(this.iDefaultWidth*3))-2;
         if (this.grids.lvlDeviceActionClass.store.count()==1) 
        	 width+=this.iDefaultWidth;
         this.grids.lvlDeviceEventEvent = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             height : this.iDefaultHeight,
             width : width,
             autoScroll : true,
             viewConfig : {
                 stripeRows : true
             },
             store : oStateDeviceEventControlStore,
             selModel : {
                             mode : 'MULTI'
             },
             columns : [ {
                 sortable : false,
                 hideable : false,
                 text : _('room'),
                 dataIndex : 'name',
                 flex : 1,                
                 renderer : function(val, metadata, record, colIdx, store, view) {
                     return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td></tr></table>';
                 }
             } ]
         });

         this.grids.lvlDeviceEventEvent.parent = this;
         this.grids.lvlDeviceEventEvent.on('itemclick', function(grid, record) {
             var event = record.get('event');
             var dSUID = record.get('dSUID');
         });
         var me=this;
         this.grids.lvlDeviceEventEvent.on('itemdblclick', function(grid, record) {
         	if (me.isValid())
         		me.fireEvent('valueDoubleClicked', me);
         });
         this.grids.lvlDeviceEventEvent.on('added', function(grid, record) {
        	 for (var sKey in me.grids) {
        		 me.grids[sKey].setHeight(me.iDefaultHeight-17);
        	 }
          });
         this.grids.lvlDeviceEventEvent.on('removed', function(grid, record) {
        	 for (var sKey in me.grids) {
        		 me.grids[sKey].setHeight(me.iDefaultHeight);
        	 }
          });
         
         this.macPanel.add(this.grids.lvlDeviceEventEvent);
         
    	
    },
    /*
    constructGridLvlDeviceEventDevice: function (zoneID) {

    	var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
    	
    	var oDeviceArray=[];
    	for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
    		if (dss.staticDataModel.deviceCache[iIndex].present)
    			if (dss.staticDataModel.deviceCache[iIndex].deviceEvents!=null)  
	    			if (Object.keys(dss.staticDataModel.deviceCache[iIndex].deviceEvents).length>0)
	    				if (dss.staticDataModel.deviceCache[iIndex].ZoneID==zoneID) {
	    					oDeviceControlStore.add(dss.staticDataModel.deviceCache[iIndex]);    					
	    				}
    	}


    	oDeviceControlStore.sort('name');
        this.grids.lvlDeviceEventDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceEventDevice.parent = this;
        this.grids.lvlDeviceEventDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventEvent);
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlDeviceEventEvent(dSUID);
        });
        this.macPanel.add(this.grids.lvlDeviceEventDevice);

		
    },*//*
    constructGridLvlDeviceEventRoom: function () {
    	var oRoomArray=[];
    	for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
    		if (dss.staticDataModel.deviceCache[iIndex].present)
    			if (dss.staticDataModel.deviceCache[iIndex].deviceEvents!=null)    				
        			if (Object.keys(dss.staticDataModel.deviceCache[iIndex].deviceEvents).length>0)    				
	    				if (oRoomArray.indexOf(dss.staticDataModel.deviceCache[iIndex].ZoneID)<0) {
	    					oRoomArray.push(dss.staticDataModel.deviceCache[iIndex].ZoneID);
	    				}
    	}
        var oRoomDeviceEventControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oArray=[];
        for (var iIndex=0;iIndex<oRoomArray.length;iIndex++) {
        	oArray.push({ZoneID:oRoomArray[iIndex],name:dss.staticDataModel.getNameForZone(oRoomArray[iIndex])});
        }
        oRoomDeviceEventControlStore.add(oArray);
        oRoomDeviceEventControlStore.sort('name');
        
        this.grids.lvlDeviceEventRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomDeviceEventControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlDeviceEventRoom.parent = this;
        this.grids.lvlDeviceEventRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventEvent);
            var zoneID = record.get('ZoneID');
            this.parent.constructGridLvlDeviceEventDevice(zoneID);           
        });
        this.macPanel.add(this.grids.lvlDeviceEventRoom);
    },*/
    constructGridLvlDeviceActionAction: function (dSUID) {
    	
        var oStateDeviceActionControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'action','dSUID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

    	var oCustom=dss.staticDataModel.getDevice(dSUID).deviceCustomActions;
    	var oStandard=dss.staticDataModel.getDevice(dSUID).deviceStandardActions;
    	var oActionArray=[];
    	
    	for (var sKey in oCustom) {
    		oActionArray.push({action:sKey,dSUID:dSUID,name:oCustom[sKey].title});
    	}
    	
    	if (Object.keys(oCustom).length>0)
    		if (Object.keys(oStandard).length>0)
    			oActionArray.push({action:'',dSUID:dSUID,name:'-'});
    	
    	for (var sKey in oStandard) {
    		oActionArray.push({action:sKey,dSUID:dSUID,name:oStandard[sKey].title});
    	}
    	
    	oStateDeviceActionControlStore.add(oActionArray);
    	     
        var width=(this.getWidth()-(this.iDefaultWidth*4))-2;
        if (this.grids.lvlDeviceActionClass.store.count()==1) 
       	 width+=this.iDefaultWidth;
    	
         this.grids.lvlDeviceActionAction = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             height : this.iDefaultHeight,
             width : width,
             autoScroll : true,
             viewConfig : {
                 stripeRows : true
             },
             store : oStateDeviceActionControlStore,
             selModel : {
                 mode : 'MULTI'
             },
             columns : [ {
                 sortable : false,
                 hideable : false,
                 text : _('room'),
                 dataIndex : 'name',
                 flex : 1,                
                 renderer : function(val, metadata, record, colIdx, store, view) {
                	 if (record.get('name')=='-')
                		 return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
                	 else
                		 return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td></tr></table>';
                 }
             } ]
         });

         this.grids.lvlDeviceActionAction.parent = this;
         this.grids.lvlDeviceActionAction.on('itemclick', function(grid, record) {
             var action = record.get('action');
             var dSUID = record.get('dSUID');
         });
         var me=this;
         this.grids.lvlDeviceActionAction.on('itemdblclick', function(grid, record) {
         	if (me.isValid())
         		me.fireEvent('valueDoubleClicked', me);
         });
         
         this.macPanel.add(this.grids.lvlDeviceActionAction);
         
    	
    },
    /*
    constructGridLvlDeviceActionDevice: function (zoneID) {

    	var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
    	
    	var oDeviceArray=[];
    	for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
    		var fSkip=false;
    		if (dss.staticDataModel.deviceCache[iIndex].present)
    			if (dss.staticDataModel.deviceCache[iIndex].deviceCustomActions!=null)  
	    			if (Object.keys(dss.staticDataModel.deviceCache[iIndex].deviceCustomActions).length>0)
	    				if (dss.staticDataModel.deviceCache[iIndex].ZoneID==zoneID) {
	    					oDeviceControlStore.add(dss.staticDataModel.deviceCache[iIndex]);
	    					fSkip=true;
	    				}
    		if (!fSkip)
	    		if (dss.staticDataModel.deviceCache[iIndex].present)
	    			if (dss.staticDataModel.deviceCache[iIndex].deviceStandardActions!=null)  
		    			if (Object.keys(dss.staticDataModel.deviceCache[iIndex].deviceStandardActions).length>0)
		    				if (dss.staticDataModel.deviceCache[iIndex].ZoneID==zoneID) {
		    					oDeviceControlStore.add(dss.staticDataModel.deviceCache[iIndex]);    					
		    				}
    	}


    	oDeviceControlStore.sort('name');
        this.grids.lvlDeviceActionDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceActionDevice.parent = this;
        this.grids.lvlDeviceActionDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionAction);
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlDeviceActionAction(dSUID);
        });
        this.macPanel.add(this.grids.lvlDeviceActionDevice);

		
    },*//*
    constructGridLvlDeviceActionRoom: function () {
    	var oRoomArray=[];
    	for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
    		if (dss.staticDataModel.deviceCache[iIndex].present)
    			if (dss.staticDataModel.deviceCache[iIndex].deviceCustomActions!=null)    				
	    			if (Object.keys(dss.staticDataModel.deviceCache[iIndex].deviceCustomActions).length>0)
	    				if (oRoomArray.indexOf(dss.staticDataModel.deviceCache[iIndex].ZoneID)<0) {
	    					oRoomArray.push(dss.staticDataModel.deviceCache[iIndex].ZoneID);
	    				}

    		if (dss.staticDataModel.deviceCache[iIndex].present)
    			if (dss.staticDataModel.deviceCache[iIndex].deviceStandardActions!=null)    				
	    			if (Object.keys(dss.staticDataModel.deviceCache[iIndex].deviceStandardActions).length>0)
	    				if (oRoomArray.indexOf(dss.staticDataModel.deviceCache[iIndex].ZoneID)<0) {
	    					oRoomArray.push(dss.staticDataModel.deviceCache[iIndex].ZoneID);
	    				}
    	}
        var oRoomDeviceActionControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oArray=[];
        for (var iIndex=0;iIndex<oRoomArray.length;iIndex++) {
        	oArray.push({ZoneID:oRoomArray[iIndex],name:dss.staticDataModel.getNameForZone(oRoomArray[iIndex])});
        }
        oRoomDeviceActionControlStore.add(oArray);
        oRoomDeviceActionControlStore.sort('name');
        
        this.grids.lvlDeviceActionRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oRoomDeviceActionControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlDeviceActionRoom.parent = this;
        this.grids.lvlDeviceActionRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionAction);
            var zoneID = record.get('ZoneID');
            this.parent.constructGridLvlDeviceActionDevice(zoneID);           
        });
        this.macPanel.add(this.grids.lvlDeviceActionRoom);
        
    },    
    */
    constructGridLvlClusterStateCluster: function () {
        var oClusterStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oClusterStore = Ext.data.StoreManager.lookup('triggerConfigurator_clusterStore');
        oClusterStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('_id') != 0)
                oClusterStateControlStore.add(oNewRecord);
        });
        oClusterStateControlStore.sort('name');

        this.grids.lvlClusterStateCluster = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oClusterStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('cluster'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlClusterStateCluster.parent = this;
        this.grids.lvlClusterStateCluster.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlClusterStateState);

            var clusterID = record.get('_id');
            this.parent.constructGridLvlClusterStateState(clusterID);
        });
        this.macPanel.add(this.grids.lvlClusterStateCluster);
    },
    constructGridLvlDeviceAKMValue : function (dSUID, type) {
        var oStore = Ext.create('Ext.data.Store', {
            fields : [ 'name','_id','next','icon','tooltip','index' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oDevice=dss.staticDataModel.getDevice(dSUID);
        
        var fSkip=false;
        if (oDevice.specialActions!=null)
        	if (oDevice.specialActions.triggers!=null)
        		if (oDevice.specialActions.triggers.binaryInputs!=null) {        			
        			for (var sKey in oDevice.specialActions.triggers.binaryInputs) 	                			
            			if (oDevice.specialActions.triggers.binaryInputs[sKey].id==type) {            				 
            				var oItem={
     	                            'index':oDevice.specialActions.triggers.binaryInputs[sKey].id,
     	                            'name':oDevice.specialActions.triggers.binaryInputs[sKey].name,
     	                            '_id':(oDevice.specialActions.triggers.binaryInputs[sKey].value=='active'),
     	                            'tooltip':'',
     	                            'icon': null};
     	                    oStore.add(oItem);
     	                    
            				fSkip=true;
                		}
        		}
        
        if (!fSkip) {        
	        if (dss.staticDataModel.getDeviceType(oDevice) == 10) { //TNY
	            for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
	                if (oDevice.binaryInputs[iIndex].type == type) {
	                    var oItem={
	                            'index':oDevice.binaryInputs[iIndex].index,
	                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,false),
	                            '_id':false,
	                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,false),
	                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,false)};
	                    oStore.add(oItem);
	                    oItem={
	                            'index':oDevice.binaryInputs[iIndex].index,
	                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,true),
	                            '_id':true,
	                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,true),
	                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,true)};
	                    oStore.add(oItem);
	                }
	            }
	            
	        } else {
	            var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);
	            for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
	                if (!bIsWindowHandle) {
	                    var oItem={
	                            'index':oDevice.binaryInputs[iIndex].index,
	                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,false),
	                            '_id':false,
	                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,false),
	                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,false)};
	                    oStore.add(oItem);
	
	                    oItem={
	                            'index':oDevice.binaryInputs[iIndex].index,
	                            'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,true),
	                            '_id':true,
	                            'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,true),
	                            'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,true)};
	                    oStore.add(oItem);
	                } else {
	                    if (oDevice.binaryInputs[iIndex].type == 15)  { // BinaryInputIDWindowTilt
	                        var oItem={
	                                'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Closed),
	                                '_id':dss.whState.WH_Closed,
	                                'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Closed),
	                                'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Closed),
	                                'index':oDevice.binaryInputs[iIndex].index};
	                        oStore.add(oItem);
	                        oItem={
	                                'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Open),
	                                '_id':dss.whState.WH_Open,
	                                'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Open),
	                                'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Open),
	                                'index':oDevice.binaryInputs[iIndex].index};
	                        oStore.add(oItem);
	                        oItem={
	                                'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Tilted),
	                                '_id':dss.whState.WH_Tilted,
	                                'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Tilted),
	                                'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,dss.whState.WH_Tilted),
	                                'index':oDevice.binaryInputs[iIndex].index};
	                        oStore.add(oItem);
	                    }
	                }
	            }
	        }
        }
        this.grids.lvlDeviceAKMValue = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : (this.getWidth()-(this.iDefaultWidth*3))-2,//150 + 174,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },           
            store : oStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('type'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        var me=this;
        this.grids.lvlDeviceAKMValue.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });

        
        this.grids.lvlDeviceAKMValue.parent = this;

        this.macPanel.add(this.grids.lvlDeviceAKMValue);
    }, 
    constructGridLvlDeviceAKMs : function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present','type' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getDeviceAKMStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            if ((oNewRecord.get('present'))||me.fIgnorePresence) {
                var oDevice = dss.staticDataModel.getDevice(oNewRecord.get('dSUID'));
                var fSkip=false;
                if (oDevice.specialActions!=null)
                	if (oDevice.specialActions.triggers!=null)
                		if (oDevice.specialActions.triggers.binaryInputs!=null) {
                			var typeArray=[];
                			for (var sKey in oDevice.specialActions.triggers.binaryInputs) 	                			
	                			if (typeArray.indexOf(oDevice.specialActions.triggers.binaryInputs[sKey].id)==-1) {
	                				var oObject={
	                					dSUID:oNewRecord.get('dSUID'),
	                					name:oNewRecord.get('name'),
	                					icon:oNewRecord.get('icon'),
	                					present:oNewRecord.get('present'),
	                					type:oDevice.specialActions.triggers.binaryInputs[sKey].id
	                				}
		                            typeArray.push(oDevice.specialActions.triggers.binaryInputs[sKey].id);
		                            oDeviceControlStore.add(oObject);
		                			fSkip=true;
		                		}
                		}
                if (!fSkip) {
	                if (dss.staticDataModel.getDeviceType(oDevice) == 10 /*TNY*/) {
	                    for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++) {
	                            type=oDevice.binaryInputs[kIndex].type;
	                            if (type!=255) {
	                                var oInput = oNewRecord.copy();
	                                var typeName = dss.staticDataModel.getNameForAKMType(type);
	                                oInput.data.name = typeName;
	                                oInput.data.type = type;
	                                oDeviceControlStore.add(oInput);
	                            }
	                    }
	                } else {
	                	oDeviceControlStore.add(oNewRecord);
	                }
                }
            }
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlAKMDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlAKMDevice.parent = this;
        this.grids.lvlAKMDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
            var dSUID = record.get('dSUID');
            var type = record.get('type');
            this.parent.constructGridLvlDeviceAKMValue(dSUID, type);
        });
        this.macPanel.add(this.grids.lvlAKMDevice);
    },
    constructGridLvlAKM:function (){
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneAKMStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        this.grids.lvlAKMRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlAKMRoom.parent = this;
        this.grids.lvlAKMRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
            this.parent.macPanel.remove(this.parent.grids.lvlAKMDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlUserstate);
            this.parent.macPanel.remove(this.parent.grids.lvlUserstateValue);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionClass);            
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventEvent);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionAction);
            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlDeviceAKMs(zoneID);
        });
        this.macPanel.add(this.grids.lvlAKMRoom);
    },
    constructGridLvlDeviceActions : function(dSUID) {
        var oDeviceActionControlStore = Ext.create('Ext.data.Store', {
            fields : [ '_id', 'name', 'icon', 'next','type' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oDeviceObject = dss.staticDataModel.getDevice(dSUID);
        var fSpecial=false;
        if (oDeviceObject.specialActions.triggers!=null) {
            if (oDeviceObject.specialActions.triggers.deviceMsg!=null) {
            	fSpecial=true;
            	for (var sKey in oDeviceObject.specialActions.triggers.deviceMsg) {            		
                	oDeviceActionControlStore.add({
                        _id : oDeviceObject.specialActions.triggers.deviceMsg[sKey].id,
                        name : oDeviceObject.specialActions.triggers.deviceMsg[sKey].name,
                        icon : null,
                        next : false,
                        type:'deviceMSG'
                   });
            	}
            } 
            if (oDeviceObject.specialActions.triggers.deviceAction!=null) {
            	fSpecial=true;
            	for (var sKey in oDeviceObject.specialActions.triggers.deviceAction) {            		
                	oDeviceActionControlStore.add({
                        _id : oDeviceObject.specialActions.triggers.deviceAction[sKey].id,
                        name : oDeviceObject.specialActions.triggers.deviceAction[sKey].name,
                        icon : null,
                        next : false,
                        type:'deviceMSG'
                   });
            	}
            } 
            if (oDeviceObject.specialActions.triggers.deviceActions!=null) {
            	fSpecial=true;
            	for (var sKey in oDeviceObject.specialActions.triggers.deviceActions) {            		
                	oDeviceActionControlStore.add({
                        _id : oDeviceObject.specialActions.triggers.deviceActions[sKey].action,
                        name : oDeviceObject.specialActions.triggers.deviceActions[sKey].name,
                        icon : null,
                        next : false,
                        type:'deviceMSG'
                   });
            	}
            } 
        }
        if (!fSpecial)
        	if (oDeviceObject.tasterMode == 15) {
            if (oDeviceObject.buttonType==2) {
                oDeviceActionControlStore.add({
                    _id : 1000,
                    name : _('switch down'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1001,
                    name : _('switch up'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
            } else if ((oDeviceObject.buttonType>=16) && (oDeviceObject.buttonType<=21)) {
                oDeviceActionControlStore.add({
                    _id : 1002,
                    name : _('switch down'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1003,
                    name : _('switch up'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
            }else if ((oDeviceObject.buttonType==13) && (oDeviceObject.HWInfo.indexOf("F6-02-FF")>=0)) {
                oDeviceActionControlStore.add({
                    _id : 1100,
                    name : _('1x click lower switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1101,
                    name : _('2x click lower switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1102,
                    name : _('3x click lower switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1103,
                    name : _('4x click lower switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1106,
                    name : _('hold lower switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
            	
                
                oDeviceActionControlStore.add({
                    _id : 1200,
                    name : _('1x click upper switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1201,
                    name : _('2x click upper switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1202,
                    name : _('3x click upper switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1203,
                    name : _('4x click upper switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1206,
                    name : _('hold upper switch'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
            	
                
            } else {                        
                oDeviceActionControlStore.add({
                    _id : 0,
                    name : _('1x click'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 1,
                    name : _('2x click'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 2,
                    name : _('3x click'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 3,
                    name : _('4x click'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                oDeviceActionControlStore.add({
                    _id : 6,
                    name : _('hold'),
                    icon : null,
                    next : false,
                    type:'deviceMSG'
                });
                /*oDeviceActionControlStore.add({
                    _id : 10,
                    name : 'Kurz-Lang',
                    icon : null,
                    next : false
                });*/
            }
        } else {
            oDeviceActionControlStore.add({
                _id : 50,
                name : _('local off'),
                icon : null,
                next : false,
                type:'deviceMSG'
            });
            oDeviceActionControlStore.add({
                _id : 51,
                name : _('local on'),
                icon : null,
                next : false,
                type:'deviceMSG'
            });
        }
        var width=(this.getWidth()-(this.iDefaultWidth*4))-2;
        if (this.grids.lvlDeviceActionClass.store.count()==1) 
       	 width+=this.iDefaultWidth;
        this.grids.lvlDeviceAction = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : width,//324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oDeviceActionControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('taster action'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceAction.parent = this;

        var me=this;
        this.grids.lvlDeviceAction.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        
        this.macPanel.add(this.grids.lvlDeviceAction);

    },    
    constructGridLvlAccess : function() {
    	
        this.grids.lvlAccess = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : (this.getWidth()-(this.iDefaultWidth*1))-2,//624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_accessStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlAccess.parent = this;

        this.grids.lvlAccess.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        
        var me=this;
        this.grids.lvlAccess.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        
        this.macPanel.add(this.grids.lvlAccess);

    },
    constructGridLvlWeather : function() {
        this.grids.lvlWeather = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_weatherStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlWeather.parent = this;

        this.grids.lvlWeather.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlSunProtection);
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            } else if (record.get('_id') === 'sun') {
                this.parent.constructGridLvlSunProtection();
            }
        });
        
        var me=this;
        this.grids.lvlWeather.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        this.macPanel.add(this.grids.lvlWeather);
    },
    constructGridLvlSunProtection : function() {
        this.grids.lvlSunProtection = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : (this.getWidth()-(this.iDefaultWidth*2))-2,//470,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_weatherSunStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlSunProtection.parent = this;

        this.grids.lvlSunProtection.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }
        });
        
        var me=this;
        this.grids.lvlSunProtection.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        this.macPanel.add(this.grids.lvlSunProtection);
    },
    constructGridLvlUserstateValue : function(stateID) {
		var oAddonStateStore = Ext.create('Ext.data.Store', {
			fields : [ '_id', 'name', 'passive', 'icon' ],
			proxy : {
			    type : 'memory',
			reader : {
			    type : 'json',
			root : 'items'
			        }
			    }
		});
        	 
    	var oState=null;
    	for (var iIndex=0;iIndex<dss.staticDataModel.userStates.length;iIndex++) {
    		if (dss.staticDataModel.userStates[iIndex].name==stateID) {
    			oState = dss.staticDataModel.userStates[iIndex];
    		}
    	}
    	if (oState!=null) {
	        var oItem={
	        	_id: 'active',
	            name: oState.setName,
	            icon: dss.staticDataModel.baseImagePath +  "state/uds_state_active.png",
	            passive: false};
	        oAddonStateStore.add(oItem);
	        var oItem={_id: 'inactive',
	            name: oState.resetName,
	            icon: dss.staticDataModel.baseImagePath +  "state/uds_state_inactive.png",
	            passive: false};
	        oAddonStateStore.add(oItem);
    	}
    		
    	
        this.grids.lvlUserstateValue = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width :(this.getWidth()-(this.iDefaultWidth*2))-102,// 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oAddonStateStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlUserstateValue.parent = this;

        this.grids.lvlUserstateValue.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        
        var me=this;
        this.grids.lvlUserstateValue.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        
        this.macPanel.add(this.grids.lvlUserstateValue);
    },
    constructGridLvlUserstate : function() {

        this.grids.lvlUserstate = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width :this.iDefaultWidth+100,// 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_userStateStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('state'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlUserstate.parent = this;

        this.grids.lvlUserstate.on('itemclick', function(grid, record) {
        	this.parent.macPanel.remove(this.parent.grids.lvlUserstateValue);
            this.parent.constructGridLvlUserstateValue(record.get('_id') );
        });
        
      
        this.macPanel.add(this.grids.lvlUserstate);
    },
    constructGridLvlPanic : function() {

        this.grids.lvlPanic = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : (this.getWidth()-(this.iDefaultWidth*1))-2,//624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : Ext.data.StoreManager.lookup('triggerConfigurator_securityStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlPanic.parent = this;

        this.grids.lvlPanic.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
        });
        
        var me=this;
        this.grids.lvlPanic.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        
        this.macPanel.add(this.grids.lvlPanic);
    },
    constructGridLvlDeviceActionClass: function(dSUID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ '_id','name','dsuid','type' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;

        var oDevice=dss.staticDataModel.getDevice(dSUID);

        var dsidActions=false;
        if (((oDevice.tasterMode == 0) && (oDevice.buttonType != 65))||(oDevice.tasterMode==15))
        	dsidActions=true;      
        
        if (oDevice.deviceEvents!=null)
    		if (Object.keys(oDevice.deviceEvents).length>0) {
    			oDeviceControlStore.add({_id:1,name:_('device events'),dsuid:dSUID});
    			dsidActions=false;
    		}
        
        var actions=false;
        if (oDevice.deviceCustomActions!=null)
    		if (Object.keys(oDevice.deviceCustomActions).length>0)
    			actions=true;
        if (oDevice.deviceStandardActions!=null)
    		if (Object.keys(oDevice.deviceStandardActions).length>0)
    			actions=true;
        if (actions) {
    		oDeviceControlStore.add({_id:2,name:_('device actions'),dsuid:dSUID});
    		dsidActions=false;
        }
        if (oDevice.hasStates) {
        	var oStates=dss.staticDataModel.getDeviceStates(dSUID);
        	for (var sKey in oStates) {
        		oDeviceControlStore.add({_id:3,name:oStates[sKey].title,dsuid:dSUID,type:sKey});
        		dsidActions=false;
        	}
        }

    	if (oDevice.specialActions!=null)
        	if (oDevice.specialActions.triggers!=null) {
            	if (oDevice.specialActions.triggers.deviceMsg!=null)
            		dsidActions=true;
            	if (oDevice.specialActions.triggers.deviceAction!=null)
            		dsidActions=true;                        	
        	}
        if (dsidActions)
        	oDeviceControlStore.add({_id:4,name:_('taster action'),dsuid:dSUID});
        
        this.grids.lvlDeviceActionClass = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : (oDeviceControlStore.count()<2)?0:this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });
        this.grids.lvlDeviceActionClass.parent = this;
        this.grids.lvlDeviceActionClass.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventEvent);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateValue);
            switch (record.get('_id')) {
        	case 1: //device events
        		this.parent.constructGridLvlDeviceEventEvent(dSUID);
            	break;
        	case 2: // device actions
        		this.parent.constructGridLvlDeviceActionAction(dSUID);
            	break;
        	case 3: //device states
        		this.parent.constructGridLvlDeviceStateValue(dSUID,record.get('type')); 
            	break;
        	case 4: //device messages
        		this.parent.constructGridLvlDeviceActions(dSUID);
            	break;
            }
            //this.parent.constructGridLvlDeviceActionClass(dSUID);
        });
        this.macPanel.add(this.grids.lvlDeviceActionClass);
        if (oDeviceControlStore.count()==1) {
        	this.grids.lvlDeviceActionClass.getSelectionModel().select(0);
        	var oRecordDeviceClass =oDeviceControlStore.getAt(0);
            switch (oRecordDeviceClass.get('_id')) {
            	case 1: //device events
            		this.constructGridLvlDeviceEventEvent(dSUID);
            		return true;                	
            	case 2: // device actions
            		this.constructGridLvlDeviceActionAction(dSUID);
            		return true;
            	case 3: //device states
            		this.constructGridLvlDeviceStateValue(dSUID,record.get('type')); 
            		return true;
            	case 4: //device messages
            		this.constructGridLvlDeviceActions(dSUID);
            		return true;
             }
        }
        return false;
    },
    constructGridLvlDevice : function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getDeviceStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            var fAKM=false;
            for (var iIndex=0;iIndex<dss.staticDataModel.getAKMDeviceArray().length;iIndex++) {
            	if (oNewRecord.get('dSUID')==dss.staticDataModel.getAKMDeviceArray()[iIndex].dSUID)
            		fAKM=true;
            }            
            if (!fAKM)
                if ((oNewRecord.get('present'))||me.fIgnorePresence)
                    oDeviceControlStore.add(oNewRecord);
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDevice.parent = this;
        this.grids.lvlDevice.on('itemclick', function(grid, record) {

        	this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionClass);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventEvent);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateValue);

            
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlDeviceActionClass(dSUID);
        });
        this.macPanel.add(this.grids.lvlDevice);
    },
    constructGridLvlGroupScene : function(zoneID, groupID, fAll, fForced) {
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ '_id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForced == null)
            fForced = false;
        if (zoneID==-1)
            zoneID=0;
        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            _id : -3,
            name : _('show all scenes'),
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll

        });
        oSceneControlStore.add({
            _id : -1,
            name : '-',
            passive:true,
            icon : null,
            reachable : true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable') || fAll)
                if (oNewRecord.get('_id') < 64)
                    oSceneControlStore.add(oNewRecord);
        });

        this.grids.lvlScene = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width :(this.getWidth()-(this.iDefaultWidth*3))-2,// 324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlScene.parent = this;

        var me=this;
        this.grids.lvlScene.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        
        
        this.grids.lvlScene.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }

            if (record.get('checkable') != null)
                if (record.get('checkable')) {
                    this.getSelectionModel().deselect(record);
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('_id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            _id : -3,
                            name : _('show all scenes'),
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });
                        grid.store.add({
                            _id : -1,
                            name : '-',
                            passive:true,
                            icon : null,
                            reachable : true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('_id') < 64)
                                    grid.store.add(oNewRecord);
                        });

                    }
                }

        });
        this.macPanel.add(this.grids.lvlScene);

    },
    constructGridLvlRoomRoom : function() {
    	var me=this;
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneZoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            var fSkip=false;
            if (oNewRecord.get('ZoneID') != 0)
            	if (!fSkip)
            		oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        oZoneControlStore.add({
            'ZoneID' : -1,
            'name' : _('any room')
        });
        this.grids.lvlRoomRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoomRoom.parent = this;
        this.grids.lvlRoomRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlGroup(zoneID);
        });
        
        var me=this;
        this.grids.lvlRoomRoom.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        this.macPanel.add(this.grids.lvlRoomRoom);
    },
    constructGridLvlDeviceRoom : function() {
    	var me=this;
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_deviceZoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            var fSkip=false;
        	var oDeviceStore = me.getDeviceStore(oNewRecord.get('ZoneID'));
        	if (oDeviceStore.count()==0)
        		fSkip=true;
            if (oNewRecord.get('ZoneID') != 0)
            	if (!fSkip)
            		oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');

        this.grids.lvlDeviceRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,                
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlDeviceRoom.parent = this;
        this.grids.lvlDeviceRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
        	this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionClass);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventEvent);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateValue);

            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlDevice(zoneID);
        });
        
        var me=this;
        this.grids.lvlDeviceRoom.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        this.macPanel.add(this.grids.lvlDeviceRoom);
    },
    constructGridLvlHigh : function() {
        var oStore = Ext.create('Ext.data.Store', {
            fields : [ {name:'name',sortType:'asUCText'} ,'_id'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (dss.staticDataModel.HLECache!=null)
            if (dss.staticDataModel.HLECache.length>0) {
                for (var iIndex=0;iIndex<dss.staticDataModel.HLECache.length;iIndex++)
                    oStore.add( {   
                        name:dss.staticDataModel.HLECache[iIndex].name,
                        _id:dss.staticDataModel.HLECache[iIndex].id
                    });
            }
        oStore.sort('name','ASC');
        this.grids.lvlHighLevelEvent = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width :(this.getWidth()-(this.iDefaultWidth*1))-2,// 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('user def. actions'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr style="height:16px;"><td width="100%">' + record.get('name') + '</td></tr></table>';
                }
            } ]
        });
        this.grids.lvlHighLevelEvent.parent = this;
        
        
        var me=this;
        this.grids.lvlHighLevelEvent.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        this.macPanel.add(this.grids.lvlHighLevelEvent);
    },
    constructGridLvlGroup : function(zoneID) {
        var oGroupControlStore = Ext.create('Ext.data.Store', {
            fields : [ '_id', 'group', 'name', 'icon', 'reachable' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oGroupStore = this.getGroupStore(zoneID);
        oGroupStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable')) {
            	var fOK=true;
            	switch (oNewRecord.get('group')) {
	            	case 0:
	            	case 6:
	            	case 7:
	            	case 8:
	            	case 16:
	            	case 17:
	            	case 18:
	            	case 19:
	            	case 20:
	            	case 21:
	            	case 22:
	            	case 23:
		            	fOK=false;
		            	break; 
            	}
                if (fOK) {
                    oGroupControlStore.add(oNewRecord);
                }
            }
        });
        oGroupControlStore.add({
            group : -1,
            name : '-',
            passive:'-',
            icon : null,
            reachable : true
        });
        var oSceneGroup0Store;
        if (zoneID == 0)
            oSceneGroup0Store = this.getSceneStore(dss.staticDataModel.getZoneArray()[1].ZoneID, 0);
        else
            oSceneGroup0Store = this.getSceneStore(zoneID, 0);
        oSceneGroup0Store.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable'))
                oGroupControlStore.add(oNewRecord);
        });

        this.grids.lvlGroup = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oGroupControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('activity'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlGroup.on('itemclick', function(grid, record) {
            if (record.get('group') == -1) {
                grid.getSelectionModel().deselect(record);
                return;
            }

            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('_id') == 0) {
                var zoneID = this.parent.grids.lvlRoomRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = record.get('group');
                if ((zoneID != null) && (groupID != null)) {
                    this.parent.constructGridLvlGroupScene(zoneID, groupID);
                    this.getSelectionModel().deselectAll();
                    this.getSelectionModel().select(record);
                }
                if (groupID == null) {
                    grid.store.each(function(record) {
                        if (record.get('group') != null)
                            grid.getSelectionModel().deselect(record);
                    });
                }
            }
        });
        
        var me=this;
        this.grids.lvlGroup.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        this.grids.lvlGroup.parent = this;
        this.macPanel.add(this.grids.lvlGroup);
    },
    constructGridLvlSensorMessage:function (dSUID) {
    	var me=this;
        var oStore = Ext.create('Ext.data.Store', {
            fields : [ 'name' ,'_id'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oSensorMessageStore = this.getSensorMessage(dSUID);
        oSensorMessageStore.each(function(record) {
            var oNewRecord = record.copy();
            oStore.add(oNewRecord);
        });
        
        this.grids.lvlSensorMessage = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width :(this.getWidth()-(this.iDefaultWidth*3))-2,// 324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'MULTI'
            },
            store : oStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('message'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr style="height:16px;"><td width="100%">' + record.get('name') + '</td></tr></table>';
                }
            } ]
        });
        this.grids.lvlSensorMessage.parent = this;
        this.macPanel.add(this.grids.lvlSensorMessage);
        
        var me=this;
        this.grids.lvlSensorMessage.on('itemdblclick', function(grid, record) {
        	if (me.isValid())
        		me.fireEvent('valueDoubleClicked', me);
        });
        
    },
    constructGridLvlSensorDevice:function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getSensorDeviceStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            if ((oNewRecord.get('present'))||me.fIgnorePresence)
                oDeviceControlStore.add(oNewRecord);
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlSensorDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlSensorDevice.parent = this;
        this.grids.lvlSensorDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlSensorMessage(dSUID);
        });
        this.macPanel.add(this.grids.lvlSensorDevice);
    },
    constructGridLvlSensor:function (){
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('triggerConfigurator_zoneSensorStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        this.grids.lvlSensorRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlSensorRoom.parent = this;
        this.grids.lvlSensorRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionClass);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);
            this.parent.macPanel.remove(this.parent.grids.lvlUserstate);
            this.parent.macPanel.remove(this.parent.grids.lvlUserstateValue);
            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlSensorDevice(zoneID);
        });
        this.macPanel.add(this.grids.lvlSensorRoom);
    },
    constructMacGrids : function() {
        var lvl1Store;
    	if (this.grids.lvl1==null) {
	        var lvl1TempStore = Ext.create('Ext.data.Store', {
	            fields : [ '_id', 'name', 'next', 'icon' ],
	            proxy : {
	                type : 'memory',
	                reader : {
	                    type : 'json',
	                    root : 'items'
	                }
	            }
	        });
	
	        lvl1Store = Ext.data.StoreManager.lookup('triggerConfigurator_l1Store');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            lvl1TempStore.add(oNewRecord);
	        });
	        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
	            hideHeaders:true,
	            height : this.iDefaultHeight,
	            width : this.iDefaultWidth,
	            autoScroll : true,
	            viewConfig : {
	                stripeRows : true
	            },
	            selModel : {
	                mode : 'MULTI'
	            },
	            store : lvl1TempStore,
	            columns : [ {
	                sortable : false,
	                hideable : false,
	                text : _('Action'),
	                dataIndex : 'name',
	                flex : 1,
	                renderer : this.defMacGridRenderer
	            } ]
	        });
	        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
	        this.grids.lvl1.parent = this;
	
	        this.grids.lvl1.on('itemclick', function(grid, record) {
	            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
	            this.parent.macPanel.remove(this.parent.grids.lvlRoomRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlDeviceRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlHighLevelEvent);
	            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
	            this.parent.macPanel.remove(this.parent.grids.lvlScene);
	            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
	            this.parent.macPanel.remove(this.parent.grids.lvlSensorRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlSensorDevice);
	            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);            
	            this.parent.macPanel.remove(this.parent.grids.lvlWeather);
	            this.parent.macPanel.remove(this.parent.grids.lvlPanic);
	            this.parent.macPanel.remove(this.parent.grids.lvlAccess);
	            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
	            this.parent.macPanel.remove(this.parent.grids.lvlAKMDevice);
	            this.parent.macPanel.remove(this.parent.grids.lvlAKMRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlUserstate);
	            this.parent.macPanel.remove(this.parent.grids.lvlUserstateValue);
	            this.parent.macPanel.remove(this.parent.grids.lvlRoomStateState);
	            this.parent.macPanel.remove(this.parent.grids.lvlRoomStateRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlClusterStateCluster);
	            this.parent.macPanel.remove(this.parent.grids.lvlClusterStateState);
                this.parent.macPanel.remove(this.parent.grids.lvlSunProtection);
                this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateRoom);
                this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateDevice);
                this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateState);
                this.parent.macPanel.remove(this.parent.grids.lvlDeviceStateValue);
                this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionClass);
                this.parent.macPanel.remove(this.parent.grids.lvlDeviceEventEvent);
                this.parent.macPanel.remove(this.parent.grids.lvlDeviceActionAction);

                
	            var fIsPassive=false;
	            if (record.get('passive')!=null) {
	                if (record.get('passive')==true) {
	                    this.getSelectionModel().deselect(record);
	                    fIsPassive=true;
	                }
	            }
	            if (!fIsPassive) {
	                if (record.get('_id') == 0) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlRoomRoom();
	                } else if (record.get('_id') == 1) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlDeviceRoom();
	                } else if (record.get('_id') == 2) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlHigh();
	                } else if (record.get('_id') == 3) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlSensor();
	                } else if (record.get('_id') == 4) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlAccess();
	                } else if (record.get('_id') == 5) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlWeather();
	                } else if (record.get('_id') == 6) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlPanic();
	                } else if (record.get('_id') == 7) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlAKM();
	                } else if (record.get('_id') == 8) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlUserstate();
	                } else if (record.get('_id') == 9) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);	                    
	                    this.parent.constructGridLvlRoomStateRoom();
	                } else if (record.get('_id') == 10) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);	                    
	                    this.parent.constructGridLvlDeviceStateRoom();
	                } else if (record.get('_id') == 11) {
	                    this.getSelectionModel().deselectAll();
	                    this.getSelectionModel().select(record);
	                    this.parent.constructGridLvlClusterStateCluster();
	                } else {
	                    grid.store.each(function(record) {
	                        if (record.get('_id') < 7)
	                            grid.getSelectionModel().deselect(record);
	                    });
	                }
	            }
	            this.parent.macPanel.doLayout();
	        }); 
    	} else {
        	this.grids.lvl1.getStore().removeAll();
        	var mThis=this;        	
	        lvl1Store = Ext.data.StoreManager.lookup('triggerConfigurator_l1Store');
	        lvl1Store.each(function(record) {
	            var oNewRecord = record.copy();
	            mThis.grids.lvl1.getStore().add(oNewRecord);
	        });
    	}

    },
    constructor : function(config) {
    	this.addEvents('valueDoubleClicked');
    	var mThis=this;
    	this.grids={};
        this.fEnableUsergroup=false;
        if (config.enableUsergroup!=null)
        	this.fEnableUsergroup=config.enableUsergroup;
        
    	this.ShowUserstates=true;
        if (config.userStates)
        	this.ShowUserstates=config.userStates;
        
        this.fHeatingOperationMode=false;
        if (config.heatingOperationMode!=null)
        	this.fHeatingOperationMode=config.heatingOperationMode;

        this.fIgnorePresence=false;
        if (config.ignorePresence!=null)
        	this.fIgnorePresence=config.ignorePresence;

        
        Ext.data.StoreManager.on('clear',function () {mThis.initStores(mThis.ShowUserstates);mThis.constructMacGrids();});
        
        this.initStores(this.ShowUserstates);
        this.constructMacGrids();

        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            autoScroll : true,
            height : 320,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            scroll : 'horizontal'
        });
        Ext.apply(this, {
            items : [ this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
        this.setValue([]);
    },
    setValue : function(values) {

        this.macPanel.remove(this.grids.lvlDeviceAction);
        this.macPanel.remove(this.grids.lvlRoomRoom);
        this.macPanel.remove(this.grids.lvlDeviceRoom);
        this.macPanel.remove(this.grids.lvlHighLevelEvent);
        this.macPanel.remove(this.grids.lvlGroup);
        this.macPanel.remove(this.grids.lvlScene);
        this.macPanel.remove(this.grids.lvlDevice);
        this.macPanel.remove(this.grids.lvlSensorRoom);
        this.macPanel.remove(this.grids.lvlSensorDevice);
        this.macPanel.remove(this.grids.lvlSensorMessage);
        this.macPanel.remove(this.grids.lvlWeather);
        this.macPanel.remove(this.grids.lvlPanic);
        this.macPanel.remove(this.grids.lvlAccess);        
        this.macPanel.remove(this.grids.lvlDeviceAKMValue);
        this.macPanel.remove(this.grids.lvlAKMDevice);
        this.macPanel.remove(this.grids.lvlAKMRoom);
        this.macPanel.remove(this.grids.lvlUserstate);
        this.macPanel.remove(this.grids.lvlUserstateValue);
        this.macPanel.remove(this.grids.lvlRoomStateState);
        this.macPanel.remove(this.grids.lvlRoomStateRoom);
        this.macPanel.remove(this.grids.lvlClusterStateCluster);
        this.macPanel.remove(this.grids.lvlClusterStateState);
        this.macPanel.remove(this.grids.lvlSunProtection);
        this.macPanel.remove(this.grids.lvlDeviceStateRoom);
        this.macPanel.remove(this.grids.lvlDeviceStateDevice);
        this.macPanel.remove(this.grids.lvlDeviceStateState);
        this.macPanel.remove(this.grids.lvlDeviceStateValue);
        this.macPanel.remove(this.grids.lvlDeviceActionClass);
        this.macPanel.remove(this.grids.lvlDeviceEventEvent);
        this.macPanel.remove(this.grids.lvlDeviceActionAction);

        
        var fGridConstructed = false;

        this.grids.lvl1.getSelectionModel().deselectAll();
        if (values==null)
        if (values.length==0)
        {
        	return;
        }
        
        for ( var vIndex = 0; vIndex < values.length; vIndex++) {
            var oValue = values[vIndex];
            switch (oValue.type) {
	            case 'device-named-event':
	                var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
	                if (!fGridConstructed) {
	                	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);
	                	this.constructGridLvlDeviceRoom();
	                    var oRecordZone = this.grids.lvlDeviceRoom.store.find('ZoneID', zoneID,0,false,false,true);
	                    if (oRecordZone != -1)
	                        this.grids.lvlDeviceRoom.getSelectionModel().select(oRecordZone);
	                    else 
	                        break;
	                    this.constructGridLvlDevice(zoneID);
	                    var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else
                            break;
                        var fConstructed=this.constructGridLvlDeviceActionClass(oValue.dsuid);
	                    var oRecordDeviceClass = this.grids.lvlDeviceActionClass.store.find('_id', 1,0,false,false,true);
                        if (oRecordDeviceClass != -1)
                            this.grids.lvlDeviceActionClass.getSelectionModel().select(oRecordDeviceClass);
                        else
                            break;
                        if (!fConstructed)
	                    this.constructGridLvlDeviceEventEvent(oValue.dsuid);
	                }
	                var iIndex=this.grids.lvlDeviceEventEvent.store.find('event', oValue.id,0,false,false,true);
	                if (iIndex!=-1)
	                    this.grids.lvlDeviceEventEvent.getSelectionModel().select(iIndex,true);
	        	break;
	            case 'device-named-action':
	                var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
	                if (!fGridConstructed) {
	                	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);
	                	this.constructGridLvlDeviceRoom();
	                    var oRecordZone = this.grids.lvlDeviceRoom.store.find('ZoneID', zoneID,0,false,false,true);
	                    if (oRecordZone != -1)
	                        this.grids.lvlDeviceRoom.getSelectionModel().select(oRecordZone);
	                    else 
	                        break;
	                    this.constructGridLvlDevice(zoneID);
	                    var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else
                            break;
                        var fConstructed=this.constructGridLvlDeviceActionClass(oValue.dsuid);
	                    
	                    var oRecordDevice = this.grids.lvlDeviceActionClass.store.find('_id', 2,0,false,false,true);
	                    if (oRecordDevice != -1)
	                        this.grids.lvlDeviceActionClass.getSelectionModel().select(oRecordDevice);
	                    else 
	                        break;
	                    if (!fConstructed)
	                    this.constructGridLvlDeviceActionAction(oValue.dsuid);
	                }
	                var iIndex=this.grids.lvlDeviceActionAction.store.find('action', oValue.id,0,false,false,true);
	                if (iIndex!=-1)
	                    this.grids.lvlDeviceActionAction.getSelectionModel().select(iIndex,true);
	        	break;
                case 'device-sensor':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',3,false,false,true),true);                    	
                        this.constructGridLvlSensor();
                        var oRecordZone = this.grids.lvlSensorRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlSensorRoom.getSelectionModel().select(oRecordZone);
                        else 
                            break;
                        this.constructGridLvlSensorDevice(zoneID);
                        var oRecordDevice = this.grids.lvlSensorDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlSensorDevice.getSelectionModel().select(oRecordDevice);
                        else 
                            break;
                        this.constructGridLvlSensorMessage(oValue.dsuid);
                    }
                     var iIndex=this.grids.lvlSensorMessage.store.find('_id', oValue.eventid,0,false,false,true);
                    if (iIndex!=-1)
                        this.grids.lvlSensorMessage.getSelectionModel().select(iIndex,true);
                break;

                case 'device-binary-input':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);                    	
                        this.constructGridLvlRoom();
                        var oRecordZone = this.grids.lvlDeviceRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlDeviceRoom.getSelectionModel().select(oRecordZone);
                        else
                            break;
                        this.constructGridLvlDevice(zoneID);
                        var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else
                            break;
                        this.constructGridLvlDeviceActions(oValue.dsuid);
                    }
                     if (oValue.state==1) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1002,0,false,false,true);      
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    }
                    if (oValue.state==0) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1003,0,false,false,true);      
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    }
                    
                break;
                case 'device-action':
                case 'device-msg':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);                    	

                        this.constructGridLvlDeviceRoom();
                        var oRecordZone = this.grids.lvlDeviceRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlDeviceRoom.getSelectionModel().select(oRecordZone);
                        else
                            break;
                        this.constructGridLvlDevice(zoneID);
                        var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else
                            break;
                        var fConstructed = this.constructGridLvlDeviceActionClass(oValue.dsuid);
	                    var oRecordDeviceClass = this.grids.lvlDeviceActionClass.store.find('_id', 4,0,false,false,true);
                        if (oRecordDeviceClass != -1)
                            this.grids.lvlDeviceActionClass.getSelectionModel().select(oRecordDeviceClass);
                        else
                            break;
                        if (!fConstructed)
                        	this.constructGridLvlDeviceActions(oValue.dsuid);
                    }
                    if (oValue.action!=null) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', oValue.action,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    } else
                    if ((oValue.msg == 0) && (oValue.buttonIndex!=null)) {
                        if (oValue.buttonIndex==2) {
                            var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1000,0,false,false,true);      
                            if (iIndex!=-1)
                                this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                        }
                        if (oValue.buttonIndex==1) {
                            var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1001,0,false,false,true);      
                            if (iIndex!=-1)
                                this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                        }
                    } else if (oValue.msg == 7) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 0,0,false,false,true);      
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    } else if (oValue.msg == 8) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    } else if (oValue.msg == 9) {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', 2,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    } else {
                        var iIndex = this.grids.lvlDeviceAction.store.find('_id', oValue.msg,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    }

                break;
                case 'undo-zone-scene': {
                    if (oValue.zone == 0)                    	
                    	switch (oValue.scene) {
		                	case 65:		                	
		                	case 74:
		                	case 83:
		                	case 84:
		                	case 85:
		                		if (!fGridConstructed) {
		                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',6,false,false,true),true);                    	
			                        this.constructGridLvlPanic();
		                		}
	                    		var oRecordScene = this.grids.lvlPanic.store.find('_id', 1000+oValue.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
		            		break;
		            	}
                }
                break;
                case 'addon-state-change': {
                	if (oValue["addon-id"]=='system-addon-user-defined-states') {
                		var stateName=oValue.name;
                		if (!fGridConstructed) {
                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',8,false,false,true),true);                    	
                            this.constructGridLvlUserstate();
                		}
                		var oRecordScene = this.grids.lvlUserstate.store.find('_id', stateName,0,false,false,true);
                        if (oRecordScene != -1) {
                            this.grids.lvlUserstate.getSelectionModel().select(oRecordScene,true);
                            this.constructGridLvlUserstateValue(stateName);
                            var oRecordValue = this.grids.lvlUserstateValue.store.find('_id', oValue.state,0,false,false,true);
                            if (oRecordValue != -1)
                            	this.grids.lvlUserstateValue.getSelectionModel().select(oRecordValue,true);
                        }
                        break;                    	
                	}
                	break;
                }
                case 'state-change':
                	
        			var idString =oValue.name;
        			var valueString=oValue.state;
        			var oUserStates=dss.staticDataModel.getUserStates();
        			var oParameter={};
        			var fSkipAfterUserstateFound=false;
        			for (var jIndex=0;jIndex<oUserStates.length;jIndex++) {
            			if (oUserStates[jIndex].name==idString) {
            				if (!fGridConstructed) {
                            	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',8,false,false,true),true);                    	
                                this.constructGridLvlUserstate();
                    		}
                    		var oRecordScene = this.grids.lvlUserstate.store.find('_id', idString,0,false,false,true);
                            if (oRecordScene != -1) {
                                this.grids.lvlUserstate.getSelectionModel().select(oRecordScene,true);
                                this.constructGridLvlUserstateValue(idString);
                                var oRecordValue = this.grids.lvlUserstateValue.store.find('_id', valueString,0,false,false,true);
                                if (oRecordValue != -1)
                                	this.grids.lvlUserstateValue.getSelectionModel().select(oRecordValue,true);
                            }
                            fSkipAfterUserstateFound=true;                            
            			}
            		}
        			if (fSkipAfterUserstateFound)
        				break;
                	
                	
                	//  name, state : 'active', 'inactive'
                	var oArray=oValue.name.split('.');
                	if (oArray.length==3) {
	                	if (oArray[0]=='dev')
	                	{
	                		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
	                		if (oDevice!=null) {
	                			if ((oDevice.hasStates) && (dss.staticDataModel.getDeviceStates(oArray[1]))) {
	                				if (!fGridConstructed) {
	            	                	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);
	            	                	this.constructGridLvlDeviceRoom();
	            	                    var oRecordZone = this.grids.lvlDeviceRoom.store.find('ZoneID', oDevice.ZoneID,0,false,false,true);
	            	                    if (oRecordZone != -1)
	            	                        this.grids.lvlDeviceRoom.getSelectionModel().select(oRecordZone);
	            	                    else 
	            	                        break;
	            	                    this.constructGridLvlDevice(oDevice.ZoneID);
	            	                    var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oDevice.dSUID,0,false,false,true);
	                                    if (oRecordDevice != -1)
	                                        this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
	                                    else
	                                        break;
	                                    var fConstructed= this.constructGridLvlDeviceActionClass(oDevice.dSUID);
	                                    var oRecordDeviceClass=-1;
	                                    for (var iIndex=0;iIndex<this.grids.lvlDeviceActionClass.store.count();iIndex++) {
	                                    	if (this.grids.lvlDeviceActionClass.store.getAt(iIndex).get('_id')==3)
	                                    		if (this.grids.lvlDeviceActionClass.store.getAt(iIndex).get('type')==oArray[2])
	                                    			oRecordDeviceClass=iIndex;
	                                    }	                                    
	                                    if (oRecordDeviceClass != -1)
	                                        this.grids.lvlDeviceActionClass.getSelectionModel().select(oRecordDeviceClass);
	                                    else
	                                        break;
	                                    if (!fConstructed)
			                        	this.constructGridLvlDeviceStateValue(oArray[1],oArray[2]);
	                				}
	                				var oRecordValue=this.grids.lvlDeviceStateValue.store.find('type',oValue.state,0,false,false,true);
		                            if (oRecordValue != -1) {
			                        	this.grids.lvlDeviceStateValue.getSelectionModel().select(oRecordValue,true);
		                            }
		                            break;
	                			} else {
		                			if (!fGridConstructed) {
		                            	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',7,false,false,true),true);                    	
		                                this.constructGridLvlAKM();
			                			var oRecordZone=this.grids.lvlAKMRoom.store.find('ZoneID', oDevice.ZoneID,0,false,false,true);
			                            if (oRecordZone != -1) {
			                                this.grids.lvlAKMRoom.getSelectionModel().select(oRecordZone,true);
			                                this.constructGridLvlDeviceAKMs(oDevice.ZoneID);
			                                var oRecordDevice=-1;
			                                for (var iIndex=0;iIndex<this.grids.lvlAKMDevice.store.count();iIndex++) {
			                                	if (this.grids.lvlAKMDevice.store.getAt(iIndex).get('dSUID')==oArray[1]) {
			                                		if (this.grids.lvlAKMDevice.store.getAt(iIndex).get('type')!=null) {
				                                		if (("" + this.grids.lvlAKMDevice.store.getAt(iIndex).get('type'))==("" + oArray[2]))
				                                			oRecordDevice=iIndex;
			                                		} else
			                                			oRecordDevice=iIndex;
			                                	}
			                                }
			                                if (oRecordDevice != -1) 
			                                	oRecordDevice=this.grids.lvlAKMDevice.store.find('dSUID', oArray[1],0,false,false,true);
				                            if (oRecordDevice != -1) {
				                            	this.grids.lvlAKMDevice.getSelectionModel().select(oRecordDevice,true);
				                            	this.constructGridLvlDeviceAKMValue(oArray[1],oArray[2]);
				                            }
			                            }
		                			}
		                				                			                			
		                			var oRecordValue=this.grids.lvlDeviceAKMValue.store.findBy(function(record) {
		                				if ((""+record.get('index'))==(""+oArray[2])) {
		                					if (record.get('_id')===true)
			                					if (oValue.state=='active')
			                						return true;
		                					if (record.get('_id')===false)
			                					if (oValue.state=='inactive')
			                						return true;
			                				if (record.get('_id')===2)
			                					if (oValue.state=='active')
			                						return true;
			                				if (record.get('_id')===1)
			                					if (oValue.state=='inactive')
			                						return true;
		                				}
		                				return false;
		                			});
	
		                			if (oRecordValue != -1)
		                				this.grids.lvlDeviceAKMValue.getSelectionModel().select(oRecordValue,true);
		                			break;
	                			}
	                		}
	                	}
	                	if (oArray[0]=='zone') {
	                		if (!fGridConstructed) {
                                this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',9,false,false,true),true);
                                this.constructGridLvlRoomStateRoom();
                            	var oRecordZone=this.grids.lvlRoomStateRoom.store.find('ZoneID', parseInt(oArray[1],10),0,false,false,true);
	                            if (oRecordZone != -1) {
	                            	this.grids.lvlRoomStateRoom.getSelectionModel().select(oRecordZone,true);
	                            	this.constructGridLvlRoomStateState(parseInt(oArray[1],10));
	                            	var oRecordState=this.grids.lvlRoomStateState.getStore().find('valueandstate',oValue.name+'_'+oValue.state);
	                            	if (oRecordState!=null)
	                            		this.grids.lvlRoomStateState.getSelectionModel().select(oRecordState);
	                            	
	                            }
	                            break;
	                		}
	                	}
                        if (oArray[0] == 'cluster') {
                            if (!fGridConstructed) {
                                this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',9,false,false,true),true);
                                this.constructGridLvlClusterStateCluster();
                                var oRecordZone=this.grids.lvlClusterStateCluster.store.find('id', parseInt(oArray[1],10),0,false,false,true);
                                if (oRecordZone != -1) {
                                    this.grids.lvlClusterStateCluster.getSelectionModel().select(oRecordZone,true);
                                    this.constructGridLvlClusterStateState(parseInt(oArray[1],10));
                                    var oRecordState=this.grids.lvlClusterStateState.getStore().find('valueandstate',oValue.name+'_'+oValue.state);
                                    if (oRecordState!=null) {
                                        this.grids.lvlClusterStateState.getSelectionModel().select(oRecordState);
                                    }
                                }
                                break;
                            }
                        }
                	}
                	if (oValue.name=='fire') {
                		if (!fGridConstructed) {
                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',6,false,false,true),true);                    	
                            this.constructGridLvlPanic();
                		}
                		var oRecordScene = this.grids.lvlPanic.store.find('_id', oValue.name + '_' + oValue.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
                	} else {
                		if (!fGridConstructed) {
                        	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',5,false,false,true),true);                    	
                            this.constructGridLvlWeather();
                		}
                		var oRecordScene = this.grids.lvlWeather.store.find('_id', oValue.name + '_' + oValue.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlWeather.getSelectionModel().select(oRecordScene,true);                		
                	}
                	
                break;
                case 'zone-scene':
                    if (oValue.zone == 0) {
                    	
                    	switch (oValue.scene) {
	                    	case 65:
	                    	case 74:
	                    	case 83:
	                    	case 84:
	                    	case 85:
	                    		if (!fGridConstructed) {
	                            	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',6,false,false,true),true);                    	
		                            this.constructGridLvlPanic();
	                    		}
	                    		var oRecordScene = this.grids.lvlPanic.store.find('_id', oValue.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
                    		break;
	                    	case 73:
	                    	case 72:
	                    	case 71:
	                    		if (!fGridConstructed) {
	                            	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',4,false,false,true),true);                    	
		                            this.constructGridLvlAccess();
	                    		}
	                    		var oRecordScene = this.grids.lvlAccess.store.find('_id', oValue.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlAccess.getSelectionModel().select(oRecordScene,true);
                    		break;
                    	}
                    	
                    	
                    
                    } else {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',0,false,false,true),true);                    	
                        if (!fGridConstructed) {                        	
                            this.constructGridLvlRoomRoom();
                            var oRecordZone = this.grids.lvlRoomRoom.store.find('ZoneID', oValue.zone,0,false,false,true);
                            if (oRecordZone != -1)
                                this.grids.lvlRoomRoom.getSelectionModel().select(oRecordZone);
                            else {
                           
                            	break;
                            }
                                
                            if (oValue.zone == -1)
                                this.constructGridLvlGroup(0);
                            else
                                this.constructGridLvlGroup(oValue.zone);
                        }
                        if (oValue.group == 0) {
                            var oRecordGroup = this.grids.lvlGroup.store.find('_id', oValue.scene,0,false,false,true);
                            if (oRecordGroup != -1)
                                this.grids.lvlGroup.getSelectionModel().select(oRecordGroup,true);
                            else {
                            	
                                break;
                            }
                        } else {
                            var oRecordGroup = this.grids.lvlGroup.store.find('group', oValue.group,0,false,false,true);
                            if (oRecordGroup != -1)
                                this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                            else {
                            	
                                break;
                            }
                            if (!fGridConstructed) {
                                this.constructGridLvlGroupScene(oValue.zone, oValue.group, false, false);
                            }
                            var oRecordScene = this.grids.lvlScene.store.find('_id', oValue.scene,0,false,false,true);
                            if (oRecordScene != -1) {
                            	if (oValue.forced!=null)
                            		if (oValue.forced)
                            			oRecordScene++;
                                this.grids.lvlScene.getSelectionModel().select(oRecordScene,true);
                            } else {
                                this.macPanel.remove(this.grids.lvlScene);
                                if (!fGridConstructed) {
                                    this.constructGridLvlGroupScene(oValue.zone, oValue.group, true, false);
                                }
                                var oRecordScene = this.grids.lvlScene.store.find('_id', oValue.scene,0,false,false,true);
                                if (oRecordScene != -1) {
                                	if (oValue.forced!=null)
                                		if (oValue.forced)
                                			oRecordScene++;
                                    this.grids.lvlScene.getSelectionModel().select(oRecordScene,true);
                                } else {
                                
                                    break;
                                }
                            }

                        }
                    }
                  
                break;
                case 'device-scene':
                    var zoneID = dss.staticDataModel.getDevice(oValue.dsuid).ZoneID;
                    if (!fGridConstructed) {
                    	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',1,false,false,true),true);                    	
                        this.constructGridLvlDeviceRoom();
                        var oRecordZone = this.grids.lvlDeviceRoom.store.find('ZoneID', zoneID,0,false,false,true);
                        if (oRecordZone != -1)
                            this.grids.lvlDeviceRoom.getSelectionModel().select(oRecordZone);
                        else
                            break;
                        this.constructGridLvlDevice(zoneID);
                        var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oValue.dsuid,0,false,false,true);
                        if (oRecordDevice != -1)
                            this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                        else 
                            break;
                        this.constructGridLvlDeviceActions(oValue.dsuid);
                    }
                    var iIndex = this.grids.lvlDeviceAction.store.find('_id', oValue.scene,0,false,false,true);
                    if (iIndex != -1)
                        this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    else {
                    	var oDevice=dss.staticDataModel.getDevice(oValue.dsuid);
                    	if (oDevice.tasterMode==0)
                    		if (oDevice.buttonType==65) {
                    			switch (oValue.scene) {
                				case 15:
                					 var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1004,0,false,false,true);      
                                     if (iIndex!=-1)
                                         this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    				break;
                				case 50:
                					 var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1006,0,false,false,true);      
                                     if (iIndex!=-1)
                                         this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    				break;
                				case 51:
                					 var iIndex = this.grids.lvlDeviceAction.store.find('_id', 1005,0,false,false,true);      
                                     if (iIndex!=-1)
                                         this.grids.lvlDeviceAction.getSelectionModel().select(iIndex,true);
                    				break;
                    			}
                    		}
                    }

                break;
                case 'custom-event':
                    if (!fGridConstructed)
                        this.constructGridLvlHigh();
                	this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',2,false,false,true),true);                    	
                    var oRecord = this.grids.lvlHighLevelEvent.store.find('_id', oValue.event,0,false,false,true);
                    if (oRecord != -1)
                        this.grids.lvlHighLevelEvent.getSelectionModel().select(oRecord,true);
                break;
                case 'event':
                    switch (oValue.name) {
                    case 'sunshine':
                        if (!fGridConstructed) {
                            this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',5,false,false,true),true);
                            this.constructGridLvlWeather();
                            this.grids.lvlWeather.getSelectionModel().select(this.grids.lvlWeather.store.find('_id', 'sun',0,false,false,true), true);
                            this.constructGridLvlSunProtection();
                        }
                        var iIndex = this.grids.lvlSunProtection.store.find('_id', 'sun_'+oValue[1][2].direction+(oValue[1][2].value == 1 ? "_active" : "_inactive"),0,false,false,true);
                        if (iIndex != -1)
                            this.grids.lvlSunProtection.getSelectionModel().select(iIndex, true);
                        break;
                    }
                break;
            }
            fGridConstructed = true;
        }
    },
    isValid : function() {
        var oValue = this.getValue();
        return (oValue.length > 0);
    },
    getValue : function() {
        var oReturnValue = [];
        try {
            var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
            for ( var iIndex = 0; iIndex < oSelectionLVL1.length; iIndex++) {
            
                if (oSelectionLVL1[iIndex].get('_id') == 4) {
                	// access trigger
                	var oSelectionScene = this.grids.lvlAccess.getSelectionModel().getSelection();
                	 
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	if (oSelectionScene[kIndex].get('_id')<1000) {
	                    	var oObject = {
	                            type : 'zone-scene',
	                            zone : 0,
	                            group : 0,
	                            scene : oSelectionScene[kIndex].get('_id')
	                        };
	                        oReturnValue.push(oObject);
                    	} else {
                    		 var oObject = {
                				 type : 'undo-zone-scene',
                				 zone : 0,
                				 group : 0,
                				 scene : oSelectionScene[kIndex].get('_id')-1000
            				 }; 
                    		 oReturnValue.push(oObject);
                    	}
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 9) {
                	var oSelectionScene = this.grids.lvlRoomStateState.getSelectionModel().getSelection();
                	// zonestate
                 	//  name, state : 'active', 'inactive' 	 
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	var sValue=oSelectionScene[kIndex].get('value');
                    	var stateName=oSelectionScene[kIndex].get('stateid');
                    	var oObject = {
	                            type : 'state-change',
	                            name : stateName,
	                            state : sValue
	                        };
	                    oReturnValue.push(oObject);                    	
                    }
                }                
                if (oSelectionLVL1[iIndex].get('_id') == 11) {
                    var oSelectionScene = this.grids.lvlClusterStateState.getSelectionModel().getSelection();
                    // clusterstate
                    //  name, state : 'active', 'inactive'
                    for (var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                        var sValue = oSelectionScene[kIndex].get('value');
                        var stateName = oSelectionScene[kIndex].get('stateid');
                        var oObject = {
                                type : 'state-change',
                                name : stateName,
                                state : sValue
                            };
                        oReturnValue.push(oObject);
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 8) {
                	var stateName = this.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('_id');
                	var stateType = this.grids.lvlUserstate.getSelectionModel().getSelection()[0].get('type');
                	var stateValue = this.grids.lvlUserstateValue.getSelectionModel().getSelection()[0].get('_id');
                	
                	// usertate
                 	//  name, state : 'active', 'inactive' 	 
                	if ((stateType=='zone-sensor-states')||(stateType=='device-sensor-states')) {
	                	var oObject = {
	                            type : 'state-change',
	                            name : stateName,
	                            state : stateValue
	                        };
	                    oReturnValue.push(oObject);
                	} else {
	                	var oObject = {
	                            type : 'addon-state-change',
	                            name : stateName,
	                            state : stateValue, 
	                            "addon-id":"system-addon-user-defined-states",
	                            "addonId":"system-addon-user-defined-states"
	                        };
	                    oReturnValue.push(oObject);
                	}
                }                
                if (oSelectionLVL1[iIndex].get('_id') == 5) {
                	var oSelectionScene = this.grids.lvlWeather.getSelectionModel().getSelection();
                	// weather
                 	//  name, state : 'active', 'inactive' 	 
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	var sValue=oSelectionScene[kIndex].get('_id');
                    	if (sValue !== 'sun') {
                        	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
                        	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
                        	var oObject = {
    	                            type : 'state-change',
    	                            name : stateName,
    	                            state : stateValue
    	                        };
                        } else {
                            var oSelectionSunProtection = this.grids.lvlSunProtection.getSelectionModel().getSelection();
                            for ( var pIndex = 0; pIndex < oSelectionSunProtection.length; pIndex++) {
                                var eventName = oSelectionSunProtection[pIndex].get('eventName');
                                var direction = oSelectionSunProtection[pIndex].get('direction');
                                var value = oSelectionSunProtection[pIndex].get('value');
                                var oObject = {
                                        type : 'event',
                                        name : eventName,
                                        parameter : {
                                            value : value,
                                            direction : direction
                                        }
                                    };
                            }
                        }
	                    oReturnValue.push(oObject);
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 6) {
                	var oSelectionScene = this.grids.lvlPanic.getSelectionModel().getSelection();
                	// panic
                    for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                    	if ((""+oSelectionScene[kIndex].get('_id')).indexOf('_')>=0) {
                        	var sValue=oSelectionScene[kIndex].get('_id');
                        	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
                        	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
                        	var oObject = {
    	                            type : 'state-change',
    	                            name : stateName,
    	                            state : stateValue
    	                        };
    	                    oReturnValue.push(oObject);                    	
                    	} else 
                    	if (oSelectionScene[kIndex].get('_id')<1000) {
	                    	var oObject = {
	                            type : 'zone-scene',
	                            zone : 0,
	                            group : 0,
	                            scene : oSelectionScene[kIndex].get('_id')
	                        };
	                        oReturnValue.push(oObject);
                    	} else {
                    		 var oObject = {
                				 type : 'undo-zone-scene',
                				 zone : 0,
                				 group : 0,
                				 scene : oSelectionScene[kIndex].get('_id')-1000
            				 }; 
                    		 oReturnValue.push(oObject);
                    	}
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 7) {
                    var oSelectionDevice = this.grids.lvlAKMDevice.getSelectionModel().getSelection()[0].get('dSUID');
                    var oSelectionIndex = this.grids.lvlDeviceAKMValue.getSelectionModel().getSelection()[0].get('index');
                    var oDevice=dss.staticDataModel.getDevice(oSelectionDevice);
                    var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);

                    if (!bIsWindowHandle) {
                        var oSelectionValue = this.grids.lvlDeviceAKMValue.getSelectionModel().getSelection()[0].get('_id');
                        var oObject = {
                            type : 'state-change',
                            name : 'dev.' + oSelectionDevice + '.' + oSelectionIndex,
                            state : (oSelectionValue ?'active':'inactive')
                        };
                        oReturnValue.push(oObject);
                    } else {
                        var oSelectionValue =  this.grids.lvlDeviceAKMValue.getSelectionModel().getSelection()[0].get('_id');
                        var oObject = {
                            type : 'state-change',
                            name : 'dev.' + oSelectionDevice + '.' + oSelectionIndex,
                            state : 'invalid'
                        };
                        if (oSelectionValue == dss.whState.WH_Closed) {
                            oObject.state = 'closed';
                        } else if (oSelectionValue == dss.whState.WH_Open) {
                            oObject.state = 'open';
                        } else if (oSelectionValue == dss.whState.WH_Tilted) {
                            oObject.state = 'tilted';
                        }
                        oReturnValue.push(oObject);
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 0) { // zone scene
                    var iZoneID = this.grids.lvlRoomRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                    var oSelectionGroup = this.grids.lvlGroup.getSelectionModel().getSelection();
                    for ( var jIndex = 0; jIndex < oSelectionGroup.length; jIndex++) {
                        if (oSelectionGroup[jIndex].get('group') == null) {
                            var oObject = {
                                type : 'zone-scene',
                                zone : iZoneID,
                                group : 0,
                                scene : oSelectionGroup[jIndex].get('_id')
                            };
                            oReturnValue.push(oObject);
                        } else {
                            var iGroupID = oSelectionGroup[jIndex].get('group');
                            var oSelectionScene = this.grids.lvlScene.getSelectionModel().getSelection();
                            for ( var kIndex = 0; kIndex < oSelectionScene.length; kIndex++) {
                                var oObject = {
                                    type : 'zone-scene',
                                    zone : iZoneID,
                                    group : iGroupID,
                                    scene : oSelectionScene[kIndex].get('_id')                                    
                                };
                                if (oSelectionScene[kIndex].get('forced')!=null)
                                    if (oSelectionScene[kIndex].get('forced')!="")
                                    	oObject.forced=oSelectionScene[kIndex].get('forced');
                                //else
                                //	oObject.forced=false;
                                oReturnValue.push(oObject);
                            }
                        }
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 1) { // taster
                    var oDSID = this.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                    var oDSUID = this.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSUID');
    
                    
                    var actionType=this.grids.lvlDeviceActionClass.getSelectionModel().getSelection()[0].get('_id');
                    if (actionType==1) {
                    	//device events
                    	for ( var jIndex = 0; jIndex < this.grids.lvlDeviceEventEvent.getSelectionModel().getSelection().length; jIndex++) {
	                    	var event=this.grids.lvlDeviceEventEvent.getSelectionModel().getSelection()[jIndex].get('event');
	                    	var oObject = {
		                            type : 'device-named-event',
		                            dsuid : oDSUID,
		                            id : event
		                        };
		                    oReturnValue.push(oObject);
                    	}
                    }
                    if (actionType==2) {
                    	//device actions
                    	for ( var jIndex = 0; jIndex < this.grids.lvlDeviceActionAction.getSelectionModel().getSelection().length; jIndex++) {
	                    	var action=this.grids.lvlDeviceActionAction.getSelectionModel().getSelection()[jIndex].get('action');
		                    var oObject = {
		                            type : 'device-named-action',
		                            dsuid : oDSUID,
		                            id : action
		                        };
		                    oReturnValue.push(oObject);
                    	}
                    }
                    if (actionType==3) {
                    	//device states
                    	for ( var jIndex = 0; jIndex < this.grids.lvlDeviceStateValue.getSelectionModel().getSelection().length; jIndex++) {
		                	var value=this.grids.lvlDeviceStateValue.getSelectionModel().getSelection()[jIndex].get('type');
		                	var state=this.grids.lvlDeviceStateValue.getSelectionModel().getSelection()[jIndex].get('selector');
		                    var oObject = {
		                            type : 'state-change',
		                            name : state,
		                            state : value
		                        };
		                    oReturnValue.push(oObject);
                    	}
                    }
                    if (actionType==4) {
	                    var oSelectionDeviceAction = this.grids.lvlDeviceAction.getSelectionModel().getSelection();
	                    
	                    var oDevice = dss.staticDataModel.getDevice(oDSUID);
	
	                    
	                    for ( var jIndex = 0; jIndex < oSelectionDeviceAction.length; jIndex++) {
	
	                        var fSpecial=false;
	                        if (oDevice.specialActions.triggers!=null) {
	                            if (oDevice.specialActions.triggers.deviceMsg!=null) {
	                            	for (var sKey in oDevice.specialActions.triggers.deviceMsg) {
	                            		if (oSelectionDeviceAction[jIndex].get('_id')==oDevice.specialActions.triggers.deviceMsg[sKey].id) {
	                            			fSpecial=true;
	                            			 var oObject = {
	                                                 dsid : oDSID,
	                                                 dsuid : oDSUID,
	                                                 type : 'device-msg',
	                                                 msg : oDevice.specialActions.triggers.deviceMsg[sKey].id
	                                             };
	                                         oReturnValue.push(oObject);
	                            		}
	                            	}
	                            }
	                        	if (oDevice.specialActions.triggers.deviceAction!=null) {
	                            	for (var sKey in oDevice.specialActions.triggers.deviceAction) {
	                            		if (oSelectionDeviceAction[jIndex].get('_id')==oDevice.specialActions.triggers.deviceAction[sKey].id) {
	                            			fSpecial=true;
	                            			 var oObject = {
	                                                 dsid : oDSID,
	                                                 dsuid : oDSUID,
	                                                 type : 'device-action',
	                                                 action : oDevice.specialActions.triggers.deviceAction[sKey].id
	                                             };
	                                         oReturnValue.push(oObject);                                         
	                            		}
	                            	}
	                            }
	                        	if (oDevice.specialActions.triggers.deviceActions!=null) {
	                            	for (var sKey in oDevice.specialActions.triggers.deviceActions) {
	                            		if (oSelectionDeviceAction[jIndex].get('_id')==oDevice.specialActions.triggers.deviceActions[sKey].action) {
	                            			fSpecial=true;
	                            			 var oObject = {
	                                                 dsid : oDSID,
	                                                 dsuid : oDSUID,
	                                                 type : 'device-action',
	                                                 action : oDevice.specialActions.triggers.deviceActions[sKey].action
	                                             };
	                                         oReturnValue.push(oObject);                                         
	                            		}
	                            	}
	                            }
	                        	
	                        }
	                    	if (!fSpecial) {                    	
		                    	if ((oSelectionDeviceAction[jIndex].get('_id') > 15) && (oSelectionDeviceAction[jIndex].get('_id') < 1000)) {
		                            var oObject = {
		                                dsid : oDSID,
		                                dsuid : oDSUID,
		                                type : 'device-scene',
		                                scene : oSelectionDeviceAction[jIndex].get('_id')
		                            };
		                            oReturnValue.push(oObject);
		                        } else {
		                        	if (oSelectionDeviceAction[jIndex].get('_id') == 1100) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    buttonIndex:1,
		                                    type : 'device-msg',
		                                    msg : 0
		                                };
		                                oReturnValue.push(oObject1);
		                                var oObject2 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    buttonIndex:1,
		                                    type : 'device-msg',
		                                    msg : 7
		                                };
		                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1200) {
		                                var oObject1 = {
			                                    dsid : oDSID,
			                                    dsuid : oDSUID,
			                                    buttonIndex:2,
			                                    type : 'device-msg',
			                                    msg : 0
			                                };
			                                oReturnValue.push(oObject1);
			                                var oObject2 = {
			                                    dsid : oDSID,
			                                    dsuid : oDSUID,
			                                    buttonIndex:2,
			                                    type : 'device-msg',
			                                    msg : 7
			                                };
			                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 0) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    msg : 0
		                                };
		                                oReturnValue.push(oObject1);
		                                var oObject2 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    msg : 7
		                                };
		                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1) {
		                                var oObject1 = {
			                                    dsid : oDSID,
			                                    dsuid : oDSUID,
			                                    type : 'device-msg',
			                                    msg : 1
			                                };
			                                oReturnValue.push(oObject1);
			                                var oObject2 = {
			                                    dsid : oDSID,
			                                    dsuid : oDSUID,
			                                    type : 'device-msg',
			                                    msg : 8
			                                };
			                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1101) {
		                                var oObject1 = {
			                                    dsid : oDSID,
			                                    dsuid : oDSUID,
			                                    type : 'device-msg',
			                                    buttonIndex:1,
			                                    msg : 1
			                                };
			                                oReturnValue.push(oObject1);
			                                var oObject2 = {
			                                    dsid : oDSID,
			                                    dsuid : oDSUID,
			                                    type : 'device-msg',
			                                    buttonIndex:1,
			                                    msg : 8
			                                };
			                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1201) {
		                            	var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:2,
		                                    msg : 1
		                                };
		                                oReturnValue.push(oObject1);
		                                var oObject2 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:2,
		                                    msg : 8
		                                };
		                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 2) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    msg : 2
		                                };
		                                oReturnValue.push(oObject1);
		                                var oObject2 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    msg : 9
		                                };
		                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1102) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:1,
		                                    msg : 2
		                                };
		                                oReturnValue.push(oObject1);
		                                var oObject2 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:1,
		                                    msg : 9
		                                };
		                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1202) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:2,
		                                    msg : 2
		                                };
		                                oReturnValue.push(oObject1);
		                                var oObject2 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:2,
		                                    msg : 9
		                                };
		                                oReturnValue.push(oObject2);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1103) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:1,
		                                    msg : 3
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1203) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:2,
		                                    msg : 3
		                                };
		                                oReturnValue.push(oObject1);
	
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1106) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:1,
		                                    msg : 6
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1206) {
		                                var oObject1 = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    buttonIndex:2,
		                                    msg : 6
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1000) {
		                                var oObject1 = {  //switch down
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    msg : 0,
		                                    buttonIndex: 2
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1001) {
		                                var oObject1 = { //switch up
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    msg : 0,
		                                    buttonIndex: 1
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1002) {
		                                var oObject1 = {  //switch down
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-binary-input',
		                                    index : 0,
		                                    state: 1
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1003) {
		                                var oObject1 = { //switch up
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-binary-input',
		                                    index : 0,
		                                    state: 0
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1004) {
		                                var oObject1 = { //controlled mode
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
			                                type : 'device-scene',
			                                scene : 15
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1005) {
		                                var oObject1 = { //forced on
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
			                                type : 'device-scene',
			                                scene : 51
		                                };
		                                oReturnValue.push(oObject1);
		                            } else if (oSelectionDeviceAction[jIndex].get('_id') == 1006) {
		                                var oObject1 = { //forced off
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
			                                type : 'device-scene',
			                                scene : 50
		                                };
		                                oReturnValue.push(oObject1);
		                            } else {
		                                var oObject = {
		                                    dsid : oDSID,
		                                    dsuid : oDSUID,
		                                    type : 'device-msg',
		                                    msg : oSelectionDeviceAction[jIndex].get('_id')
		                                };
		                                oReturnValue.push(oObject);
		                            }
		                        }
	                    	}
	                    }
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 2) { // highlvl
                    var oSelectionHighLVL = this.grids.lvlHighLevelEvent.getSelectionModel().getSelection();
                    for ( var jIndex = 0; jIndex < oSelectionHighLVL.length; jIndex++) {
                        var oObject = {
                            type : 'custom-event',
                            event : oSelectionHighLVL[jIndex].get('_id')
                        };
                        oReturnValue.push(oObject);
                    }
                }
                if (oSelectionLVL1[iIndex].get('_id') == 3) { // sensor
                    var oDSID = this.grids.lvlSensorDevice.getSelectionModel().getSelection()[0].get('dSID');
                    var oDSUID = this.grids.lvlSensorDevice.getSelectionModel().getSelection()[0].get('dSUID');
                    var oSelectionMSG = this.grids.lvlSensorMessage.getSelectionModel().getSelection();
                    for ( var jIndex = 0; jIndex < oSelectionMSG.length; jIndex++) {
                        var oObject = {
                            type : 'device-sensor',
                            dsid :oDSID, 
                            dsuid :oDSUID, 
                            eventid : oSelectionMSG[jIndex].get('_id')
                        };
                        oReturnValue.push(oObject);
                    }
                }
            }
        } 
        catch (e){}
        return oReturnValue;
    }
}); // DSS.component.Trigger

